<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// css.php
// CSS definition file
//
// Design name: Standard
// Author:      Yves Goergen
// Last edit:   20040815

header('Content-Type: text/css');
header('Expires: ' . gmdate('D, d M Y H:i:s GMT', time() + 3600 * 24));   // 1 day
include('../../bb_lib/ua.inc.php');
?>

/*--------------------  GLOBAL ELEMENTS  --------------------*/

body
{
	font: 11px/15px Verdana,Arial,sans-serif;
	margin: 0px;
	padding: 0px;
	background: #FFFFFF url(img/body_back.png);
}
body.simple
{
	margin: 0px;
	background: #FFFFFF url(img/body_back.png);
}
td.head
{
	/* border-top: solid 2px #1A3BE0; */
}
td.head td.logo
{
	padding: 10px 0px 12px 40px;
}
td.head td.time
{
	font-size: 9px;
	color: #339933;
	padding: 5px 10px;
}
td.navi
{
	background: #CCCCCC url(img/nav_back2.png);
	border-top: solid 1px #AFB2CD;
	border-bottom: solid 1px #AFB2CD;
	padding: 0px 10px;
}
table.navlinks
{
}
table.navlinks td
{
	padding: 1px 5px;
}
table.navlinks td.sel
{
	background: #D0D0D8;
}
table.navlinks td.sep
{
	padding: 1px 4px;
}
td.navi span.sep
{
	border-left: solid 1px #AFB2CD;
}
td.loginctl
{
	padding: 0px 0px;
}
td.loginctl input.text
{
	margin: 1px 0px;
}
td.loginctl input.button
{
	top: -1px;
}
td.content
{
	padding: 10px 10px 20px 10px;
}
td.foot
{
	font: 9px Verdana,Arial,sans-serif;
	color: #AAAAAA;
	padding: 3px 10px;
	border-top: solid 1px #AAAAAA;
}

a
{
	color: #0051F6;
	text-decoration: none;
}
a:hover
{
	/*border-bottom: solid 1px #4D86FB;*/
	/*text-decoration: underline;*/
	color: #FF9000;
}
a.admin
{
	color: #168816;
}
a.foot
{
	color: #AAAAAA;
}

p, td, li, div
{
	font: 11px/15px Verdana,Arial,helvetica,sans-serif;
}

.online_users
{
	font-size: 9px;
	color: #808080;
	margin-top: 3px;
}

.path
{
	margin-bottom: 8px;
}
.path .sep
{
	color: #FF4000;
}
.path .thread
{
	margin-top: 4px;
	font-size: 19px;
	line-height: 26px;
}
.path .desc
{
	font-size: 11px;
	color: #909090;
}

.actiontable
{
	margin: 3px 0px;
}
.actionbar_l, .actionbar_r
{
	color: #404040;
	padding: 2px 0px;
	margin: 3px 0px;
}
.actionbar_r
{
}

.error, .info
{
	font-weight: bold;
	color: #B00000;
	background: #FAFAFA;
	border: solid 1px #808080;
	padding: 3px;
}

.info
{
	color: #00B000;
}

input.text, textarea.text
{
	border: solid 1px #B4B4B4;
	background: #FAFAFA;
	color: #202020;
	padding: 1px 1px;
	font: 11px Verdana,Arial,sans-serif;
	<?php if ($host_browser == "MOZ" || $host_browser == "FB") { ?>
	margin-top: 2px;
	<?php } ?>
}
textarea.text
{
	<?php if ($host_browser == 'IE' || $host_browser == 'KON') { ?>
	scrollbar-arrow-color: #666666;
	scrollbar-base-color: #FFFFFF;
	scrollbar-darkshadow-color: #CCCCCC;
	scrollbar-face-color: #E8E8E8;
	scrollbar-highlight-color: #F0F0F0;
	scrollbar-shadow-color: #E0E0E0;
	scrollbar-track-color: #FFFFFF;
	<?php } ?>
}
input[type="text"]:hover,
input[type="text"]:focus,
input[type="password"]:hover,
input[type="password"]:focus,
textarea:hover,
textarea:focus
{
	border: solid 1px #5580DD;
}

input.radio
{
	<?php if ($host_browser == "IE") { ?>
	margin-top: -2px;
	position: relative;
	top: 1px;
	margin-left: -2px;
	margin-right: 2px;
	<?php } ?>
	<?php if ($host_browser == "MOZ" || $host_browser == "FB") { ?>
	margin-top: 0px;
	position: relative;
	top: 3px;
	<?php } ?>
}

select
{
	border: 1px solid ThreeDShadow !important;
	-moz-border-left-colors: #B4B4B4 #FAFAFA !important;
	-moz-border-top-colors: #B4B4B4 #FAFAFA !important;
	-moz-border-right-colors: #B4B4B4 #FAFAFA !important;
	-moz-border-bottom-colors: #B4B4B4 #FAFAFA !important;
	background: #FAFAFA !important;
	padding: 0px 0px;
}
select:hover,
select:focus
{
	border: 1px solid ThreeDShadow !important;
	-moz-border-left-colors: #5580DD #FAFAFA !important;
	-moz-border-top-colors: #5580DD #FAFAFA !important;
	-moz-border-right-colors: #5580DD #FAFAFA !important;
	-moz-border-bottom-colors: #5580DD #FAFAFA !important;
}

input.button   /* IE compliance */
{
	font: 11px Verdana,Arial;
	<?php if ($host_browser == "IE") { ?>
	height: 17px;
	<?php } ?>
	border: solid 1px #D0D0D0;
	background: #D8D8D8;
	padding: 0px 3px;
}
input[type="button"],
input[type="submit"]
{
	font: 11px Verdana,Arial;
	border: solid 1px #D0D0D0;
	background: #D8D8D8;
	padding: 0px 3px;
	position: relative;
}
input[type="button"]:hover,
input[type="submit"]:hover,
input[type="button"]:focus,
input[type="submit"]:focus
{
	border: solid 1px #5580DD;
	background: #E8EEFB;
}
input[type="button"]:active,
input[type="submit"]:active
{
	border: solid 1px #5580DD;
	background: #AAC0EE;
}
input[type="button"][disabled],
input[type="submit"][disabled]
{
	color: #808080;
	padding: 0px 3px;
}
input[type="button"][disabled]:hover,
input[type="submit"][disabled]:hover
{
	border: solid 1px #D0D0D0;
	background: #D8D8D8;
}

input[type="file"]
{
	/*-moz-appearance: textbox !important;
	border: 1px solid ThreeDShadow !important;
	-moz-border-left-colors: #B4B4B4 white !important;
	-moz-border-top-colors: #B4B4B4 white !important;
	-moz-border-right-colors: #B4B4B4 white !important;
	-moz-border-bottom-colors: #B4B4B4 white !important;
	background: #FAFAFA !important;*/
}

input.transparent
{
	font: 11px Verdana,Arial;
	border: 0px;
	background: transparent;
	color: #202020;
	margin-bottom: 1px;
}
input.transparent:hover,
input.transparent:focus
{
	border: 0px;
}

form
{
	margin: 0px;
}

small
{
	font-size: 9px;
	line-height: 12px;
	color: #707070;
}

.codelink
{
	font-size: 9px;
	line-height: 9px;
	color: #7070B0;
	<?php if($host_browser == 'IE' && $host_bver < '6.0') { ?>
	cursor: hand;
	<?php } else { ?>
	cursor: pointer;
	<?php } ?>
}

.highlight
{
	background: #FFA080;
}

option.forum
{
	color: #000000;
	background: #FFFFFF;
}
option.category
{
	color: #000000;
	background: #EEEEEE;
}
option.current
{
	color: #FFFFFF;
	background: #5080A0;
}

a img
{
	border: 0px;
}
.abbc a img
{
	border: 1px solid #0051F6;
}

/*--------------------  LIST VIEWS: MESSAGE  --------------------*/

.messagelist
{
	margin-top: 10px;
}

.list_message_warn_head_0,
.list_message_warn_head_left,
.list_message_warn_head_right
{
	background: #EAA496;
	color: #713D35;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_message_warn_head_left
{
	background: #EAA496 url(img/head_left2.png) top left no-repeat;
}
.list_message_warn_head_right
{
	background: #EAA496 url(img/head_right2.png) top right no-repeat;
}

.list_message
{
	color: #000000;
	padding: 3px 5px;
}

.list_message_warn
{
	background: #F2E4E2;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_message .date,
.list_message_warn .date
{
	color: #707070;
	font-size: 9px;
}



/*--------------------  LIST VIEWS: FORUM, CATEGORY  --------------------*/

.list_forum_head_0,
.list_forum_head_left,
.list_forum_head_right
{
	background: #9FBCE3;
	color: #3A4F6C;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_forum_head_left
{
	background: #9FBCE3 url(img/head_left2.png) top left no-repeat;
}
.list_forum_head_right
{
	background: #9FBCE3 url(img/head_right2.png) top right no-repeat;
}

.list_weblink
{
	background: #EAEFF6;
	color: #000000;
	padding: 4px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_weblink .name
{
	font-size: 13px;
	font-weight: bold;
}
.list_weblink .desc
{
	margin-top: 2px;
	color: #808080;
}

.list_category
{
	background: #CDD6E1; /* #C2CFDF */
	color: #4C77B6;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_category .name
{
	font-size: 13px;
	font-weight: bold;
}
.list_category .desc
{
	margin-top: 2px;
	color: #505050;
}

.list_category a
{
	color: #0051F6;
}
.list_category a:hover
{
}
.list_category a.admin
{
	color: #168816;
}

.list_forum,
.list_forum_0
{
	background: #EAEFF6; /* #E4EAF2 */
	color: #000000;
	padding: 4px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_forum .name
{
	font-size: 13px;
	font-weight: bold;
}
.list_forum .desc
{
	margin-top: 2px;
	color: #808080;
}

.list_editforum
{
	background: #EDDCA3;
	color: #000000;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_forum_more,
.list_forum_1,
.list_forum_2,
.list_forum_3,
.list_forum_4,
.list_forum_5
{
	background: #D9E2EF; /* #D6DFEC */
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_forum_2
{
	background: #C8D4E6;
}
.list_forum_3
{
	background: #BAC9E0;
}
.list_forum_4
{
	background: #ACBEDA;
}
.list_forum_5
{
	background: #9EB4D4;
}


/*--------------------  LIST VIEWS: THREAD  --------------------*/

.list_thread_head_0,
.list_thread_head_left,
.list_thread_head_right
{
	background: #9FBCE3;
	color: #3A4F6C;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_thread_head_left
{
	background: #9FBCE3 url(img/head_left2.png) top left no-repeat;
}
.list_thread_head_right
{
	background: #9FBCE3 url(img/head_right2.png) top right no-repeat;
}

.list_thread,
.list_thread_important
{
	background: #EAEFF6; /* #E4EAF2 */
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_thread .desc,
.list_thread_important .desc
{
	margin-top: 2px;
	font-size: 9px;
	color: #808080;
}
.list_thread_important
{
	background: #F2E4E2;
}


/*--------------------  LIST VIEWS: POST  --------------------*/

.list_post_head_0,
.list_post_head_left,
.list_post_head_right
{
	background: #9FBCE3;
	color: #3A4F6C;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_head_left
{
	background: #9FBCE3 url(img/head_left2.png) top left no-repeat;
}
.list_post_head_right
{
	background: #9FBCE3 url(img/head_right2.png) top right no-repeat;
}

/* --- old layout --- */
.list_post_old_uname_0,
.list_post_old_datesubject_0,
.list_post_old_contactaction_0,
.list_post_old_avataruinfo_0,
.list_post_old_message_0,
.list_post_old_notes_0,
.list_post_old_thread_0
{
	background: #EDECDF;
}
.list_post_old_uname_1,
.list_post_old_datesubject_1,
.list_post_old_contactaction_1,
.list_post_old_avataruinfo_1,
.list_post_old_message_1,
.list_post_old_notes_1,
.list_post_old_thread_1
{
	background: #E8EBF2;
}

.list_post_old_uname_0,
.list_post_old_uname_1
{
	color: #000000;
	padding: 3px 5px;
}
.list_post_old_datesubject_0,
.list_post_old_datesubject_1
{
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
	color: #707070;
	font-size: 9px;
}
.list_post_old_contactaction_0,
.list_post_old_contactaction_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_old_avataruinfo_0,
.list_post_old_avataruinfo_1
{
	padding: 0px 5px 3px 5px;
	border-bottom: solid 1px #FFFFFF;
	color: #808080;
	font-size: 9px;
	line-height: 13px;
}
.list_post_old_message_0,
.list_post_old_message_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_old_notes_0,
.list_post_old_notes_1
{
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
	color: #808080;
	font-size: 9px;
	line-height: 13px;
}
.list_post_old_thread_0,
.list_post_old_thread_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_post_old_delimiter
{
	height: 4px;
	line-height: 1px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_old_readline
{
	height: 4px;
	background: #909090;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_old_users
{
	/* background: #F0F0F0; */
}

/* --- new layout --- */
.list_post_new_avatar_0,
.list_post_new_unameinfo_0,
.list_post_new_date_0
{
	background: #E3E1CB;
}
.list_post_new_subject_0,
.list_post_new_message_0,
.list_post_new_notes_0,
.list_post_new_thread_0
{
	background: #EDECDF;
}
.list_post_new_avatar_1,
.list_post_new_unameinfo_1,
.list_post_new_date_1
{
	background: #D7DDE9;
}
.list_post_new_subject_1,
.list_post_new_message_1,
.list_post_new_notes_1,
.list_post_new_thread_1
{
	background: #E8EBF2;
}

.list_post_new_unameinfo_0,
.list_post_new_unameinfo_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_new_date_0,
.list_post_new_date_1
{
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
	color: #707070;
	font-size: 9px;
}
.list_post_new_subject_0,
.list_post_new_subject_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_new_message_0,
.list_post_new_message_1
{
	color: #000000;
	padding: 3px 5px;
}
.list_post_new_notes_0,
.list_post_new_notes_1
{
	padding: 3px 5px;
	border-top: solid 1px #FFFFFF;
	color: #808080;
	font-size: 9px;
	line-height: 13px;
}
.list_post_new_thread_0,
.list_post_new_thread_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_post_new_delimiter
{
	height: 4px;
	line-height: 1px;
}
.list_post_new_endline
{
	height: 1px;
}
.list_post_new_topline
{
	height: 1px;
}
.list_post_new_readline
{
	height: 4px;
	background: #909090;
}
.list_post_new_users
{
	background: #F4F4F4;
	padding: 0px 5px;
}

/* end */

.list_post_votes
{
	color: #000000;
	padding: 3px 5px;
	background: #E8EBF2;
}

.signature
{
	width: 65%;
	color: #808080;
	/*margin-top: 4px;*/
	border-top: dotted 1px #B0B0B0;
	margin-left: 20px;
	padding-top: 3px;
	padding-bottom: 7px;
}
.signature .abbc
{
	font-size: 9px;
	line-height: 12px;
}

.poll_table
{
	margin-bottom: 3px;
}

.list_post_question_0,
.list_post_question_left,
.list_post_question_right
{
	background: #104E7A;
	color: #FFFFFF;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_question_left
{
	background: #104E7A url(img/head_left2.png) top left no-repeat;
}
.list_post_question_right
{
	background: #104E7A url(img/head_right2.png) top right no-repeat;
}

.graph1
{
	font-size: 1px;
	height: 10px;
	background: #00C000;
	border-right: solid 2px #007000;
}
.graph0
{
	font-size: 1px;
	height: 10px;
	background: #D0D0D0;
}


/*--------------------  LIST VIEWS: USER  --------------------*/

.list_user_head_0,
.list_user_head_left,
.list_user_head_right
{
	background: #A5E39D;
	color: #406C3A;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_user_head_left
{
	background: #A5E39D url(img/head_left2.png) top left no-repeat;
}
.list_user_head_right
{
	background: #A5E39D url(img/head_right2.png) top right no-repeat;
}

.list_user
{
	background: #DAECDA;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #F8F8F8;
}

.list_edituser
{
	background: #EDDCA3;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #F8F8F8;
}


/*--------------------  LIST VIEWS: PROFILE  --------------------*/

.username
{
	font-weight: bold;
	font-size: 14pt;
}

.list_cp_head_0,
.list_cp_head_left,
.list_cp_head_right
{
	background: #9FBCE3;
	color: #3A4F6C;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_cp_head_left
{
	background: #9FBCE3 url(img/head_left2.png) top left no-repeat;
}
.list_cp_head_right
{
	background: #9FBCE3 url(img/head_right2.png) top right no-repeat;
}

.list_cp_n,
.list_cp_l,
.list_cp_x,
.list_cp_d
{
	background: #EFEFEF;
	color: #000000;
	padding: 3px 5px;
}
.list_cp_l,
.list_cp_d
{
	border-bottom: solid 1px #FFFFFF;
}
.list_cp_x
{
	border-left: solid 1px #FFFFFF;
}
.list_cp_d
{
	background: #E5E5E5;
	font-weight: bold;
}
.list_cp_e    /* extra fields */
{
	color: #000000;
	padding: 3px 0px;
}

.img_trans_back
{
	border: solid 1px #DDDDDD;
	background: url(img/trans_back.png);
}

table.cp_pages td.list_cp_l
{
	padding: 3px 1px;
}
.cp_nonselpage
{
	padding: 0px 4px;
}
.cp_selpage
{
	background: #E0E0E0;
	padding: 0px 4px;
}


/*--------------------  EDIT POST  --------------------*/

.edit_post_head_0,
.edit_post_head_left,
.edit_post_head_right
{
	background: #C1C1C1;
	color: #535353;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.edit_post_head_left
{
	background: #C1C1C1 url(img/head_left2.png) top left no-repeat;
}
.edit_post_head_right
{
	background: #C1C1C1 url(img/head_right2.png) top right no-repeat;
}

.edit_post
{
	background: #EFEFEF;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}


/*--------------------  SMILEYS  --------------------*/

.smiley_table
{
	background: #CCCCCC;
}

.smiley_cell_0
{
	background: #E2E2E2;
	border: solid 1px #E2E2E2;
	text-align: center;
}
.smiley_cell_1
{
	border: solid 1px #5580DD;
	background: #E8EEFB;
	text-align: center;
}

.special_char
{
	font-size: 13px;
	cursor: default;
}


/*--------------------  LIST VIEWS: CONFIG  --------------------*/

.list_config_head_0,
.list_config_head_left,
.list_config_head_right
{
	background: #C1C1C1;
	color: #535353;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_config_head_left
{
	background: #C1C1C1 url(img/head_left2.png) top left no-repeat;
}
.list_config_head_right
{
	background: #C1C1C1 url(img/head_right2.png) top right no-repeat;
}

.list_config_n,    /* no line */
.list_config_l,    /* line, horizontal */
.list_config_en,   /* editing, no h-line*/
.list_config_el,   /* editing, h-line */
.list_config_dn,   /* dark, no line */
.list_config_dl,   /* dark, h-line */
.list_config_vn,   /* vertical line, no h-line */
.list_config_vl,   /* v-line, h-line */
.list_config_vdn,  /* v-line, dark, no h-line */
.list_config_vdl   /* v-line, dark, h-line */
{
	background: #EFEFEF;
	color: #000000;
	padding: 3px 5px;
}
.list_config_l,
.list_config_dl,
.list_config_vl,
.list_config_vdl
{
	border-bottom: solid 1px #FFFFFF;
}
.list_config_en,
.list_config_el
{
	background: #EDDCA3;
}
.list_config_el
{
	border-bottom: solid 1px #FFFFFF;
}
.list_config_dn,
.list_config_dl,
.list_config_vdn,
.list_config_vdl
{
	background: #E6E6E6;
}
.list_config_vn,
.list_config_vl,
.list_config_vdn,
.list_config_vdl
{
	border-left: solid 1px #FFFFFF;
}

.yes
{
	font-weight: bold;
	color: #00A000;
}
.no
{
	font-weight: bold;
	color: #C00000;
}
.more_detailed
{
	color: #C07000;
}
.acl_disabled
{
	color: #909090;
	font-style: italic;
}

.tr_hover .list_config_l
{
	background: #E4E4E4;
}


/*--------------------  HELP  --------------------*/

.help_entry
{
	margin-top: 10px;
	border: solid 1px #CCCCCC;
	padding: 2px 4px;
}

.help_entry .keyword
{
	font-weight: bold;
	color: #0030A0;
}

.help_entry .content
{
	color: #404040;
	padding-left: 20px;
}


/*--------------------  SEARCH  --------------------*/

.search_head_0,
.search_head_left,
.search_head_right
{
	background: #CCCD8B;
	color: #6F7030;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.search_head_left
{
	background: #CCCD8B url(img/head_left2.png) top left no-repeat;
}
.search_head_right
{
	background: #CCCD8B url(img/head_right2.png) top right no-repeat;
}

.search
{
	background: #F4F4DA;
	color: #000000;
	padding: 3px 5px;
}

