<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// admin.inc.php
// Admin's tools

require($libpath . 'lang/' . $LANG . '_more.php');

if (!CheckRights('is_admin'))
{
	errorlog("access denied");
	die($T['err_access_denied']);
}

if ($_REQUEST['tool'] == 'setuid')
{
	$error = false;

	// SetUID?
	if ($_POST['action'] == 'setuid' && ($_POST['ID'] != '' || $_POST['Name'] != ''))
	{
		if ($_POST['ID'] != '')
		{
			$_SESSION['UserID'] = $_POST['ID'];
		}
		elseif ($_POST['Name'] != '')
		{
			$user = new IUser;
			if ($userid = $user->FindByName($_POST['Name']))
				$_SESSION['UserID'] = $userid;
			else
				$error .= "$T[err_invalid_user]<br />";
		}

		if (!$error)
		{
			addlog("setuid " . $_SESSION['UserID']);
			ForwardHTML($MODULE['main'] . sid(2));
			exit();
		}
	}

	BeginHTML($T['set_user']);
	addlog("admin_su");

	if ($error)
	{
		errorlog($error);
		echo '<p class="error">' . $error . '</p>';
	}

	echo '<p><b>' . $T['set_user'] . '</b></p>';

	echo '<p>';
	echo '<form action="' . $ME . PD . 'tool=setuid' . sid() . '" method="post">';
	echo '<input type="hidden" name="action" value="setuid" />';
	echo $T['username'].' '.$T['or'].' '.$T['id'] . ': <input type="text" class="text" name="Name" size="20" maxlength="40" /> <input type="submit" class="button" value="' . $T['change_uid'] . '" />';
	echo '</form>';
	echo '</p>';

	EndHTML();
}

if ($_REQUEST['tool'] == 'acl')
{
	// Import request variables
	$edit_acl = $_REQUEST['edit'];
	if (!is_numeric($edit_acl)) $edit_acl = 0;

	$add_acl = $_GET['add'] == 1;
	$error = false;

	BeginHTML($T['acl_editor']);
	addlog("admin_acl");

	// for the delete button image link...
	echo '<script type="text/javascript">' /*. '<![CDATA['*/;
	include($libpath . 'editor.js.php');
	echo /*']]>' .*/ '</script>';
	echo '<script type="text/javascript" src="' . $libpath . 'editor.js"></script>';

	if ($_REQUEST['action'] == 'edit')
	{
		if ($_REQUEST['delete'] != '')
		{
			if (!$db->RemoveRecord("ID=$edit_acl", 'ACL'))
			{
				echo '<p class="error">Error: ' . t2h($db->LastError()) . '</p>';
				$error = true;
			}
		}
		else
		{
			if ($_POST['User'] != 0 && $_POST['Group'] != 0)
			{
				echo '<p class="error">' . $T['err_acl_usr_grp_both_not_null'] . '</p>';
				$error = true;
			}

			if ($_POST['Thread'] != 0 && $_POST['Forum'] != 0)
			{
				echo '<p class="error">' . $T['err_acl_thread_forum_both_not_null'] . '</p>';
				$error = true;
			}

			if ($_POST['Action'] == 0)
			{
				echo '<p class="error">' . $T['err_acl_no_action'] . '</p>';
				$error = true;
			}

			if ($_POST['Action'] < 30 && ($_POST['Thread'] != 0 || $_POST['Forum'] != 0))
			{
				echo '<p class="error">' . $T['err_acl_global_action'] . '</p>';
				$error = true;
			}

			if (!$error)
			{
				if (20 <= $_POST['Action'] && $_POST['Action'] <= 29 || 60 <= $_POST['Action'] && $_POST['Action'] <= 79)
					$_POST['Grant'] = $_POST['Grant_num'];

				$fields = array(
					'User' => $_POST['User'],
					'Group' => $_POST['Group'],
					'Thread' => $_POST['Thread'],
					'Forum' => $_POST['Forum'],
					'Action' => $_POST['Action'],
					'Grant' => $_POST['Grant'],
					'Enabled' => ($_POST['Enabled'] ? 1 : 0)
					);

				if ($edit_acl > 0)
				{
					if (!$db->ChangeRecord($fields, "ID=$edit_acl", 'ACL'))
					{
						echo '<p class="error">Error: ' . t2h($db->LastError()) . '</p>';
						$error = true;
					}
				}
				else
				{
					$max = intval($db->FastQuery1st('ACL', 'MAX(ID)'));
					$fields['ID'] = $max + 1;
					if (!$db->AddRecord($fields, 'ACL'))
					{
						echo '<p class="error">Error: ' . t2h($db->LastError()) . '</p>';
						$error = true;
					}
				}
			}
		}

		if (!$error) $edit_acl = 0;
		elseif ($edit_acl == 0) $add_acl = 1;
	}

	// Display a single editing line for the table
	//
	// l = 'n' for no bottom border line | 'l' for a line
	//
	function EditACL($acl, $l = 'l')
	{
		global $ME, $T, $IMG, $user, $thread, $forum, $group_names, $output;

		echo '<tr>';

		echo '<td class="list_config_e' . $l . '" rowspan="2">';
		echo $T['user'] . ': <input type="text" class="text" name="User" size="4" maxlength="9" value="' . $acl['User'] . '" /> ' . $T['or'] . '<br />';
		echo $T['acl_group'] . ': <select class="text" name="Group">';
		echo '<option value="0"' . ($acl['Group'] == 0 ? ' selected="selected"' : '') . '>(' . $T['all'] . ')</option>';
		foreach ($group_names as $id => $name)
			echo '<option value="' . $id . '"' . ($acl['Group'] == $id ? ' selected="selected" class="current"' : '') . '>' . t2h($name) . '</option>';
		echo '</select>';
		echo '</td>';

		echo '<td class="list_config_e' . $l . '" colspan="2" rowspan="2">';
		echo $T['topic'] . ': <input type="text" class="text" name="Thread" size="4" maxlength="9" value="' . $acl['Thread'] . '" /> ' . $T['or'] . '<br />';
		echo $T['forum'] . ': <select class="text" name="Forum">';
		echo '<option value="0"' . ($acl['Forum'] == 0 ? ' selected="selected" class="current"' : '') . '>(' . $T['all'] . ')</option>';
		$output = '';
		ListForumsRec($acl['Forum']);
		echo $output;
		echo '</select>';
		echo '</td>';

		echo '<td class="list_config_e' . $l . '" rowspan="2">';
		echo '<select class="text" name="Action">';
		echo '<option value="0"' . ($acl['Group'] == 0 ? ' selected="selected"' : '') . ' class="category" disabled="disabled">(' . $T['acl_select_one'] . ')</option>';
		$last = 0;
		$mode = false;
		for ($n = 1; $n < 100; $n++)
		{
			if (isset($T['right_' . $n]))
			{
				if ($n - $last > 1) $mode = !$mode;
				$classname = $mode ? ' class="category"' : '';

				echo '<option value="' . $n . '"' . ($acl['Action'] == $n ? ' selected="selected" class="current"' : $classname) . '>' .
					t2h($T['right_' . $n]) . ($n >= 30 ? ' &#185;' : '') .
					'</option>';
				$last = $n;
			}
		}
		echo '</select>';
		echo '</td>';

		/*echo "<td class=list_config_e{$l} align=center>";
		echo "<nobr><label for='GrantNo'>" . $T['no'] . "</label>";
		echo "<input type=radio class=radio name='Grant' id='GrantNo' value=0" . (!$acl['Grant'] ? ' checked="checked"' : '') . " /> ";
		echo "<input type=radio class=radio name='Grant' id='GrantYes' value=1" . ($acl['Grant'] ? ' checked="checked"' : '') . " />";
		echo "<label for='GrantYes'>" . $T['yes'] . "</label></nobr>";
		echo "</td>";*/

		echo '<td class="list_config_e' . $l . '" align="center" rowspan="2">';
		echo '<input type="checkbox" class="radio" name="Grant" value="1"' . ($acl['Grant'] ? ' checked="checked"' : '') . ' /><br />';
		echo '<input type="text" class="text" name="Grant_num" value="' . intval($acl['Grant']) . '" size="6" maxlength="10" />';
		echo '</td>';

		echo '<td class="list_config_en" align="center">';
		echo '<input type="checkbox" class="radio" name="Enabled" value="1"' . ($acl['Enabled'] ? ' checked="checked"' : '') . ' />';
		echo '</td>';

		echo '<td class="list_config_en" align="right">';
		if ($acl['ID'])
		{
			echo '<a href="javascript:goDelete(\'' . $ME . PD . 'tool=acl&amp;edit=' . $acl['ID'] . '&amp;action=edit&amp;delete=1' . sid() . '\')">';
			echo '<img ' . $IMG['delete'] . ' title="' . $T['delete'] . '" /></a>';
		}
		else
			echo '&nbsp;';
		echo '</td>';

		echo '</tr>';
		echo '<tr>';

		echo '<td class="list_config_e' . $l . '" align="right" colspan="2">';
		echo '<input type="submit" name="save" class="button" value="' . $T['save'] . '" />';
		//echo "<input type=submit name='delete' class=button value=\"$T[delete]\" />";
		echo '</td>';

		echo '</tr>';
	}

	$group_names = GetGroupNames();

	echo '<form action="' . $ME . PD . 'tool=acl' . sid() . '" method="post">';
	/*if (isset($_GET['wizardthread']) && isset($_GET['wizardforum']))
	{
		$wizthread = $_GET['wizardthread'];
		$wizforum = $_GET['wizardforum'];

		echo "<input type=hidden name=action value='wizard' />";
		if ($wizthread || $wizforum)
		{
			echo "<input type=hidden name=thread value='$wizthread' />";
			echo "<input type=hidden name=forum value='$wizforum' />";

			echo "All rules for ";
			if ($_GET['wizardthread'] > 0) echo "thread $wizthread";
			elseif ($_GET['wizardforum'] > 0) echo "forum $wizforum";
			echo ":<br /><br />";
		}
		else
		{
			echo "Thread <input type=text class=text name=wizardthread size=5 /> or Forum ";
			echo "<select class=text name='wizardforum'>";
			$output = '';
			ListForumsRec(0);
			echo $output;
			echo "</select>:<br /><br />";
		}

		if ($wizforum)
		{
			$forum = new IForum;
			$allforums = array($wizforum);
			$forum->Load($wizforum);
			while ($forum->Load($forum->GetParent())) $allforums[] = $forum->GetID();
			$allforums[] = 0;
			$allforums = join(',', $allforums);
		}
		else
		{
			$allforums = '';
		}

		$GLOBALS['show_sql'] = true;
		if ($wizthread)
			$acls = $db->FastQuery1stArray('ACL', 'User',
				'Thread = ' . $wizthread . ' AND Action IN (33,82,84) AND User != 0 AND `Grant` AND Enabled',
				'User DESC');
		elseif ($wizforum)
			$acls = $db->FastQuery1stArray('ACL', 'User',
				'Forum IN (' . $allforums . ') AND Action IN (33,82,84) AND User != 0 AND `Grant` AND Enabled',
				'User DESC');
		if ($acls) $acls = join(', ', $acls);
		echo "Grant access to following users: <input type=text class=text name=grantusers size=20 value=\"$acls\"><br />";

		if ($wizthread)
			$acls = $db->FastQuery1stArray('ACL', 'User',
				'Thread = ' . $wizthread . ' AND Action IN (33,82,84) AND User != 0 AND NOT `Grant` AND Enabled',
				'User DESC');
		elseif ($wizforum)
			$acls = $db->FastQuery1stArray('ACL', 'User',
				'Forum IN (' . $allforums . ') AND Action IN (33,82,84) AND User != 0 AND NOT `Grant` AND Enabled',
				'User DESC');
		if ($acls) $acls = join(', ', $acls);
		echo "Don't grant access to following users: <input type=text class=text name=nograntusers size=20 value=\"$acls\"><br />";

		$acls = $db->FastQueryArray('ACL', '*',
			'Thread = ' . $wizthread . ' AND Forum IN (' . $allforums . ') AND Action IN (33,82,84) AND `Group` != 0',
			'`Group` DESC');

		$groups = array();
		foreach ($group_names as $id => $name) $groups[$id] = array('Grant' => 0, 'Name' => $name);
		if ($acls) foreach ($acls as $acl) $groups[$acl['Group']]['Grant'] = $acl['Grant'];

		echo "Access for user groups:<br />";
		echo "<select name='grantgroups[]' class=text size=6 multiple="multiple">";
		foreach ($groups as $id => $group)
			echo "<option value=$id" . ($group['Grant'] ? ' selected="selected"' : '') . ">" . t2h($group['Name']) . "</option>";
		echo "</select><br /><br />";

		echo "<input type=submit name='save' class=button value=\"$T[save]\"> ";
		echo "<a href='$ME" . PD . "&amp;tool=acl" . sid() . "'>Cancel</a>";
	}
	else*/
	{
		if ($edit_acl)
		{
			echo '<input type="hidden" name="action" value="edit" />';
			echo '<input type="hidden" name="edit" value="' . $edit_acl . '" />';
		}
		if ($add_acl == 1)
		{
			echo '<input type="hidden" name="action" value="edit" />';
			echo '<input type="hidden" name="edit" value="0" />';
		}

		echo '<p>';
		echo '<table cellspacing="' . $TABLE['config']['space'] . '" cellpadding="' . $TABLE['config']['pad'] . '" border="' . $TABLE['config']['border'] . '" width="100%">';
		echo '<tr valign="top">';
		echo '<td class="list_config_head_left">' . $T['user'] . '/' . $T['acl_group'] . '</td>';
		echo '<td class="list_config_head_0">' . $T['topic'] . '/' . $T['forum'] . '</td>';
		echo '<td class="list_config_head_0" width="16">&nbsp;</td>';
		echo '<td class="list_config_head_0">' . $T['acl_action'] . '</td>';
		echo '<td class="list_config_head_0" align="center">' . $T['acl_grant'] . '</td>';
		echo '<td class="list_config_head_0" align="center">' . $T['active'] . '</td>';
		echo '<td class="list_config_head_right">&nbsp;</td>';
		echo '</tr>';

		$acls = $db->FastQueryArray('ACL', '*', '', 'User DESC, `Group` DESC, Thread DESC' . $forum_order . ', Action');
		$user = new IUser;
		$thread = new IThread;
		$forum = new IForum;
		$prev_section = '';
		$curr_section = '';
		$prev_subsection = '';
		$next_subsection = '';
		$more_detailed = array();

		$x1 = 1;
		$x2 = 0;
		if ($acls)
		{
			for ($counter = 0; $counter < sizeof($acls); $counter++)
			{
				$acl = $acls[$counter];

				// group sections (user/group) by background colour
				$curr_section = $acl['User'] . ' ' . $acl['Group'];
				if ($curr_section != $prev_section) $d = (($x1 = 1 - $x1) ? 'd' : '');
				$prev_section = $curr_section;

				// group sub-sections (+forum/thread) by horizontal lines
				$next_subsection = $acls[$counter + 1]['User'] . ' ' . $acls[$counter + 1]['Group'] . ' ' . $acls[$counter + 1]['Thread'] . ' ' . $acls[$counter + 1]['Forum'];
				if ($next_subsection != $prev_subsection)
				{
					$x2 = 1;
					if (($acl['Thread'] || $acl['Forum']) && $acl['Enabled'])
						$more_detailed[$acl['Thread'] . ' ' . $acl['Forum']]++;
				}
				else $x2 = 0;
				$l = ($x2 == 1 && $acl['ID'] != $edit_acl) ? 'l' : 'n';
				$prev_subsection = $next_subsection;

				echo "<tr>";

				// display disabled lines in a lighter color
				$dis = !$acl['Enabled'];

				echo '<td class="list_config_' . $d . $l . '">';
				if ($dis) echo '<span class="acl_disabled">';
				if ($acl['User'] != 0)
				{
					if ($user->Load($acl['User']))
						echo MakeUserLink($acl['User'],
							GetUserOnlineImg($user->GetOnline()) . " " .
							t2h($user->GetName()),
							true, false, false);
					else
						echo $acl['User'] . ' <i>(' . $T['unknown'] . ')</i>';
				}
				elseif ($acl['Group'] != 0)
				{
					if (isset($group_names[$acl['Group']]))
						echo '@' . t2h($group_names[$acl['Group']]);
					else
						echo '@' . $acl['Group'] . ' <i>(' . $T['unknown'] . ')</i>';
				}
				else
				{
					echo '*';
				}
				if ($dis) echo '</span>';
				echo '</td>';

				// mark these rights, if there are more detailed (special) rights above in the table for this forum/thread
				$md = !$dis && $more_detailed[$acl['Thread'] . ' ' . $acl['Forum']] > 1;

				echo '<td class="list_config_v' . $d . $l . '">';
				// only relevant for non-global rights
				if ($acl['Action'] >= 30)
				{
					if ($md) echo '<span class="more_detailed">';
					if ($dis) echo '<span class="acl_disabled">';
					if ($acl['Thread'] != 0)
					{
						if ($thread->Load($acl['Thread']))
							echo $T['topic'] . ': ' . t2h($thread->GetSubject());
						else
							echo $T['topic'] . ': ' . $acl['Thread'] . ' <i>(' . $T['unknown'] . ')</i>';
					}
					elseif ($acl['Forum'] != 0)
					{
						if ($forum->Load($acl['Forum']))
							echo $T['forum'] . ': ' . t2h($forum->GetName());
						else
							echo $T['forum'] . ': ' . $acl['Forum'] . ' <i>(' . $T['unknown'] . ')</i>';
					}
					else
					{
						echo '*';
					}
					if ($md) echo '</span>';
					if ($dis) echo '</span>';
				}
				else
				{
					echo '&nbsp;';
				}
				echo '</td>';

				echo '<td class="list_config_' . $d . $l . '" align="right">';
				/*if (false)   #($acl['Thread'] || $acl['Forum'])
					echo "<a href='$ME" . PD . "tool=acl&wizardthread=$acl[Thread]&wizardforum=$acl[Forum]" . sid() . "'><img $IMG[wizard] title='wizard' /></a>";
				else*/
					echo '&nbsp;';
				echo '</td>';

				echo '<td class="list_config_v' . $d . $l . '">';
				if ($md) echo '<span class="more_detailed">';
				if ($dis) echo '<span class="acl_disabled">';
				if (isset($T['right_' . $acl['Action']]))
					echo $T['right_' . $acl['Action']] . ($acl['Action'] >= 30 ? ' &#185;' : '');
				else
					echo $acl['Action'] . ' <i>(' . $T['unknown'] . ')</i>';
				if ($md) echo '</span>';
				if ($dis) echo '</span>';
				echo '</td>';

				echo '<td class="list_config_' . $d . $l . '" align="center">';
				if (20 <= $acl['Action'] && $acl['Action'] <= 29 || 60 <= $acl['Action'] && $acl['Action'] <= 79)
					echo $acl['Grant'];
				else
					echo $acl['Grant'] ? '<span class="yes">' . $T['yes'] . '</span>' : '<span class="no">' . $T['no'] . '</span>';
				echo '</td>';

				echo '<td class="list_config_v' . $d . $l . '" align="center">';
				echo $acl['Enabled'] ? '<span class="yes">' . $T['yes'] . '</span>' : '<span class="no">' . $T['no'] . '</span>';
				echo '</td>';

				echo '<td class="list_config_v' . $d . $l . '" align="right">';
				if ($acl['ID'] != $edit_acl)
				{
					if ($acl['User'] == 0 && $acl['Group'] == 1 && $acl['Thread'] == 0 && $acl['Forum'] == 0 && $acl['Action'] == 82 ||
						$acl['User'] == 0 && $acl['Group'] == 2 && $acl['Thread'] == 0 && $acl['Forum'] == 0 && $acl['Action'] == 83 ||
						$acl['User'] == 0 && $acl['Group'] == 3 && $acl['Thread'] == 0 && $acl['Forum'] == 0 && $acl['Action'] == 84)
					{
						echo '&nbsp;';
					}
					else
					{
						#echo "<a href='$ME" . PD . "tool=acl&edit=" . $acl['ID'] . sid() . "'>$T[change]</a>";
						echo '<a href="' . $ME . PD . 'tool=acl&amp;edit=' . $acl['ID'] . sid() . '">';
						echo '<img ' . $IMG['edit'] . ' title="' . $T['change'] . '" />';
						echo '</a> &nbsp;';

						echo '<a href="javascript:goDelete(\'' . $ME . PD . 'tool=acl&amp;edit=' . $acl['ID'] . '&amp;action=edit&amp;delete=1' . sid() . '\')">';
						echo '<img ' . $IMG['delete'] . ' title="' . $T['delete'] . '" />';
						echo '</a>';
					}
				}
				else
					echo '&nbsp;';
				echo '</td>';

				echo '</tr>';

				$l = ($x2 == 1) ? 'l' : 'n';
				if ($acl['ID'] == $edit_acl)
				{
					if ($error) $acl = array(
						'User' => $_POST['User'],
						'Group' => $_POST['Group'],
						'Thread' => $_POST['Thread'],
						'Forum' => $_POST['Forum'],
						'Action' => $_POST['Action'],
						'Grant' => $_POST['Grant'],
						'Enabled' => $_POST['Enabled']
						);

					EditACL($acl, $l);
				}
			}
		}

		if ($add_acl == 1)
		{
			if ($error) $acl = array(
				'ID' => 0,
				'User' => $_POST['User'],
				'Group' => $_POST['Group'],
				'Thread' => $_POST['Thread'],
				'Forum' => $_POST['Forum'],
				'Action' => $_POST['Action'],
				'Grant' => $_POST['Grant'],
				'Enabled' => $_POST['Enabled']
				);
			else $acl = array(
				'ID' => 0,
				'User' => 0,
				'Group' => 0,
				'Thread' => 0,
				'Forum' => 0,
				'Action' => 0,
				'Grant' => 0,
				'Enabled' => 1
				);
			EditACL($acl);
		}

		echo '</table>';
		echo '</p>';

		echo '<p>';
		echo '<a href="' . $ME . PD . 'tool=acl&amp;add=1' . sid() . '">' . $T['acl_add_entry'] . '</a>';
		if ($edit_acl) echo ' | <a href="' . $ME . PD . 'tool=acl' . sid() . '">' . $T['acl_cancel_edit'] . '</a>';
		else           echo ' | <a href="' . $ME . PD . 'tool=acl' . sid() . '">' . $T['acl_update_view'] . '</a>';

		//echo " | <a href='$ME" . PD . "tool=acl&wizardthread=0&wizardforum=0" . sid() . "'><img $IMG[wizard] title='wizard' /> Set new thread/forum read permissions</a>";
		echo '</p>';

		echo '<p>' . $T['acl_note'] . '</p>';
	}

	echo '</form>';

	EndHTML();
}

if ($_REQUEST['tool'] == 'avatars')
{
	BeginHTML($T['avatar_overview']);

	if ($_GET['checksize'] == 1)
	{
		echo '<p>';

		$user = new IUser;
		if ($user->GetList()) do
		{
			if ($user->GetAvatar() != '')
			{
				$is = @getimagesize((strpos($user->GetAvatar(), ':') ? '' : $avatar_path) . $user->GetAvatar());
				if (is_array($is))
				{
					$newx = $is[0];
					$newy = $is[1];
				}
				else
				{
					$newx = $newy = 0;
					echo 'Warning: Can\'t read avatar of user ' . t2h($user->GetName()) . '<br />';
				}
			}
			else
			{
				$newx = $newy = 0;
			}

			if (!$db->ChangeRecord(array('AvatarX' => $newx, 'AvatarY' => $newy), 'ID=' . $user->GetID(), 'Users'))
			{
				echo 'Warning: Database error: ' . t2h($db->LastError()) . '<br />';
				break;
			}
		}
		while ($user->GetNext());

		echo '<br />' . $T['avatar_scan_ok'] . '<br /><br /><a href="' . $ME . PD . 'tool=avatars' . sid() . '">' . $T['avatar_overview'] . '</a></p>';
	}
	else
	{
		echo '<p>';
		echo '<table cellspacing="' . $TABLE['config']['space'] . '" cellpadding="' . $TABLE['config']['pad'] . '" border="' . $TABLE['config']['border'] . '" width="100%">';
		echo '<tr valign="top">';
		echo '<td class="list_config_head_left" colspan="4">' . $T['avatar_overview'] . '</td>';
		echo '<td class="list_config_head_right">&nbsp;</td>';
		echo '</tr>';

		$user = new IUser;
		$count = 0;
		$view = 0;
		if ($user->GetList("Avatar != ''", "Name"))
		{
			CountUserPosts();

			echo '<tr>';
			do
			{
				if ($count && $count % 5 == 0)
				{
					echo '</tr>';
					echo '<tr>';
				}

				echo '<td class="list_config_l" align="center">';

				// determine image size independantly...
				if ($user->AvatarFromURL() || file_exists(avatar_url($user)))
					$size = @GetImageSize(avatar_url($user));
				else
					$size = false;

				echo MakeUserLink($user->GetID(),
					'<img src="' . avatar_url($user) . '"' . avatar_size($user, false) . ' class="img_trans_back" alt="' . $T['avatar'] . '" /><br /><br />' .
						GetUserOnlineImg($user->GetOnline()) . " " .
						t2h($user->GetName()) . " " .
						GetGenderImage($user->GetGender()),
					true, false, false);
				echo '<br /><small>' . $T['member'] . ' ' . FriendlyDate($user->GetRegDate(), 2, 1, true, 1) . '<br />' .
					GetPostsByUser($user->GetID()) . ' ' . $T['posts'] . '<br />';
				if ($size) echo $size[0] . '&times;' . $size[1] . ' ' . $T['pixels'];
				echo '</small>';

				echo '</td>';

				$count++;
			}
			while ($user->GetNext());
			$view = $count;

			for (; $count % 5; $count++)
			{
				echo '<td class="list_config_l" align="center">&nbsp;</td>';
			}
			echo '</tr>';
		}

		echo '</table>';
		echo '</p>';

		echo '<p>' . $view . ' ' . ($view == 1 ? $T['avatar'] : $T['avatars']) . ' | <a href="' . $ME . PD . 'tool=avatars&amp;checksize=1' . sid() . '">' . $T['avatar_checksize'] . '</a></p>';
	}

	EndHTML();
}

if ($_REQUEST['tool'] == 'forums')
{
	#if (!CheckRights('editforum', 0)) exit();

	if (isset($_GET['moveup']) && intval($_GET['moveup']) > 0)
	{
		$forum = new IForum;
		if ($forum->Load(intval($_GET['moveup'])))
		{
			$forum->SetSort($forum->GetSort() - 1, true);
		}

		#ForwardHTML($ME . PD . "tool=forums" . sid());
		#exit();
	}

	if (isset($_GET['movedn']) && intval($_GET['movedn']) > 0)
	{
		$forum = new IForum;
		if ($forum->Load(intval($_GET['movedn'])))
		{
			$forum->SetSort($forum->GetSort() + 1, true);
		}
	}

	if (isset($_POST['submit']))
	{
		$forum = new IForum;
		reset($_POST);
		while (list ($key, $value) = each ($_POST))
		{
			if (substr($key, 0, 3) == "Del")
			{
				if ($value == 1)
				{
					$id = intval(substr($key, 3));
					$forum->Remove($id);
				}
			}
			elseif (substr($key, 0, 4) == "Sort")
			{
				$id = intval(substr($key, 4));
				if ($forum->Load($id)) $forum->SetSort($value);
			}
			elseif (substr($key, 0, 6) == "Parent")
			{
				$id = intval(substr($key, 6));
				if ($forum->Load($id)) $forum->SetParent($value);
			}
			elseif (substr($key, 0, 3) == "Cat")
			{
				$id = intval(substr($key, 3));
				if ($forum->Load($id)) $forum->SetCategory($value);
			}
			elseif (substr($key, 0, 4) == "Name")
			{
				$id = intval(substr($key, 4));
				if ($forum->Load($id)) $forum->SetName($value);
			}
		}
	}

	BeginHTML($T['forum_overview']);

	echo '<form action="' . $ME . PD . 'tool=forums' . sid() . '" method="post">';

	function ShowForum(&$forum, $level)
	{
		global $ME;
		$id = $forum->GetID();

		echo '<tr>';

		echo '<td class="list_forum_' . $level . '" align="center">' . $id . '</td>';

		echo '<td class="list_forum_' . $level . '" align="center"><input type="text" class="text" name="Parent' . $id . '" size="3" value="' . $forum->GetParent() . '" /></td>';

		echo '<td class="list_forum_' . $level . '" align="center"><a href="' . $ME . PD . 'tool=forums&amp;moveup=' . $id . sid() . '">&minus;</a> <input type="text" class="text" name="Sort' . $id . '" size="3" value="' . $forum->GetSort() . '" /> <a href="' . $ME . PD . 'tool=forums&amp;movedn=' . $id . sid() . '">+</a> </td>';

		echo '<td class="list_forum_' . $level . '" align="center"><input type="checkbox" class="radio" name="Cat' . $id . '" value="1"' . ($forum->IsCategory() ? ' checked="checked"' : '') . ' /></td>';

		echo '<td class="list_forum_' . $level . '">';
		if ($level)
		{
			echo '<small>';
			for ($n = 0; $n < $level; $n++) echo '&middot; &nbsp; ';
			echo '</small>';
		}
		echo '<input type="text" class="text" name="Name' . $id . '" size="40" maxlength="100" value="' . htmlquote($forum->GetName()) . '" /></td>';

		echo '<td class="list_forum_' . $level . '" align="center"><input type="checkbox" class="radio" name="Del' . $id . '" value="1" ' . suredelete() . ' /></td>';

		echo '</tr>';
	}

	function ListForums($parent = 0, $level = 0)
	{
		global $shown;

		if (!$level)
		{
			$shown = array();
		}

		$forum = new IForum;

		if ($forum->GetChild($parent)) do
		{
			$id = $forum->GetID();
			array_push($shown, $id);

			ShowForum($forum, $level);

			ListForums($forum->GetID(), $level + 1);
		}
		while ($forum->GetNextChild());

		if (!$level)
		{
			// show unassociated forums
			if (sizeof($shown))
				$ids = $forum->GetListArray("NOT (ID IN (" . join(',', $shown) . ")", "ID");
			else
				$ids = $forum->GetListArray("", "ID");

			$count = 0;
			if (is_array($ids)) foreach ($ids as $id)
			{
				if (!in_array($id, $shown))
				{
					if (!$count) echo '<tr><td class="list_forum_0" align="center" colspan="6"><b>Unassociated Forums:</b></td></tr>';
					$count++;

					array_push($shown, $id);
					$forum->Load($id);
					ShowForum($forum, $level);
					ListForums($forum->GetID(), $level + 1);
				}
			}
		}
	}

	echo '<table cellspacing="0" cellpadding="0" width="100%">';

	echo '<tr valign="top">';
	echo '<td class="list_cp_head_left" width="6%" align="center">ID</td>';
	echo '<td class="list_cp_head_0" width="8%" align="center">' . $T['parent'] . '</td>';
	echo '<td class="list_cp_head_0" width="11%" align="center">' . $T['sort'] . '</td>';
	echo '<td class="list_cp_head_0" width="8%" align="center">' . $T['category'] . '</td>';
	echo '<td class="list_cp_head_0" width="35%">' . $T['name'] . '</td>';
	echo '<td class="list_cp_head_right" width="8%" align="center">' . $T['delete'] . '</td>';
	echo '</tr>';

	ListForums();

	echo '</table>';

	echo '<p><input type="hidden" name="submit" value="1" /><input type="submit" class="button" value="' . $T['save'] . '" /></p>';

	echo '</form>';

	EndHTML();
}

if ($_REQUEST['tool'] == 'groups')
{
	// Import request variables
	$edit_grp = $_REQUEST['edit'];
	if (!is_numeric($edit_grp)) $edit_acl = 0;

	$add_grp = $_GET['add'] == 1;

	BeginHTML($T['groups_editor']);
	addlog("admin_groups");

	$error = false;

	if ($_POST['action'] == 'edit')
	{
		if ($_POST['delete'] != '')
		{
			if ($edit_grp > 3)
			{
				if (!$db->RemoveRecord("`Group`=$edit_grp", 'GroupMembers') ||
					!$db->RemoveRecord("ID=$edit_grp", 'GroupNames'))
				{
					echo '<p class="error">Error: ' . t2h($db->LastError()) . '</p>';
					$error = true;
				}
			}
			else
			{
				echo '<p class="error">' . $T['err_grp_default_nodelete'] . '</p>';
				$error = true;
			}
		}
		else
		{
			if (trim($_POST['Name']) == '')
			{
				echo '<p class="error">' . $T['err_grp_name_empty'] . '</p>';
				$error = true;
			}

			if (!$error)
			{
				switch ($edit_grp)
				{
					case 1: $showinteam = 0; break;
					case 2:
					case 3: $showinteam = 1; break;
					default: $showinteam = $_POST['ShowInTeam'] == 1 ? 1 : 0;
				}
				if ($edit_grp > 0)
				{
					if (!$db->ChangeRecord(array('Name' => trim($_POST['Name']), 'ShowInTeam' => $showinteam), "ID=$edit_grp", 'GroupNames'))
					{
						echo '<p class="error">Error: ' . t2h($db->LastError()) . '</p>';
						$error = true;
					}
				}
				else
				{
					$max = intval($db->FastQuery1st('GroupNames', 'max(ID)'));
					if (!$db->AddRecord(array('ID' => $max + 1, 'Name' => trim($_POST['Name']), 'ShowInTeam' => $showinteam), 'GroupNames'))
					{
						echo '<p class="error">Error: ' . t2h($db->LastError()) . '</p>';
						$error = true;
					}
				}
			}
		}

		if (!$error) $edit_grp = 0;
		elseif ($edit_grp == 0) $add_grp = 1;
	}

	// Display a single editing line for the table
	//
	function EditGroup($grp)
	{
		global $T;

		echo '<tr>';

		echo '<td class="list_config_el">';
		echo '<input type="text" class="text" name="Name" size="30" maxlength="50" value="' . $grp['Name'] . '" />';
		echo '</td>';

		echo '<td class="list_config_el">&nbsp;</td>';

		echo '<td class="list_config_el" align="center">';
		if (!$grp['ID'] || $grp['ID'] > 3)
			echo '<input type="checkbox" class="radio" name="ShowInTeam" value="1"' . ($grp['ShowInTeam'] ? ' checked="checked"' : '') . ' />';
		else
			echo '&nbsp;';
		echo '</td>';

		echo '<td class="list_config_el" align="right">';
		echo '<input type="submit" name="save" class="button" value="' . $T['save'] . '" />';
		if ($grp['ID'] > 3) echo '<input type="submit" name="delete" class="button" value="' . $T['delete'] .'" />';
		echo '</td>';

		echo '</tr>';
	}

	echo '<form action="' . $ME . PD . 'tool=groups' . sid() . '" method="post">';
	if ($edit_grp)
	{
		echo '<input type="hidden" name="action" value="edit" />';
		echo '<input type="hidden" name="edit" value="' . $edit_grp . '" />';
	}
	if ($add_grp == 1)
	{
		echo '<input type="hidden" name="action" value="edit" />';
		echo '<input type="hidden" name="edit" value="0" />';
	}

	echo '<p>';
	echo '<table cellspacing="' . $TABLE['config']['space'] .'" cellpadding="' . $TABLE['config']['pad'] . '" border="' . $TABLE['config']['border'] . '">';
	echo '<tr valign="top">';
	echo '<td class="list_config_head_left">' . $T['group_name'] . '</td>';
	echo '<td class="list_config_head_0">' . $T['members'] . '</td>';
	echo '<td class="list_config_head_0" align="center">' . $T['group_show_in_team'] . '</td>';
	echo '<td class="list_config_head_right">&nbsp;</td>';
	echo '</tr>';

	$grps = $db->FastQueryArray('GroupNames', '*', '', 'IF(ID<=3, ID, CONCAT("4", Name))');

	if ($grps)
	{
		foreach ($grps as $grp)
		{
			$l = ($grp['ID'] == $edit_grp) ? 'n' : 'l';

			echo '<tr>';

			echo '<td class="list_config_' . $l . '">';
			echo t2h($grp['Name']);
			echo '</td>';

			echo '<td class="list_config_' . $l . '" align="right">';
			echo sizeof(GetGroupMembers($grp['ID']));
			echo '</td>';

			/*switch ($grp['ID'])
			{
				case 1: $showinteam = 0; break;
				case 2:
				case 3: $showinteam = 1; break;
				default: $showinteam = $grp['ShowInTeam'];
			}*/
			$showinteam = $grp['ShowInTeam'];
			echo '<td class="list_config_' . $l . '" align="center">';
			echo $showinteam ? '<span class="yes">' . $T['yes'] . '</span>' : '<span class="no">' . $T['no'] . '</span>';
			echo '</td>';

			echo '<td class="list_config_' . $l . '">';
			if ($grp['ID'] != $edit_grp)
			{
				//echo '<a href="' . $ME . PD . 'tool=groups&amp;edit=' . $grp['ID'] . sid() . '">' . $T['change'] . '</a>';
				echo '<a href="' . $ME . PD . 'tool=groups&amp;edit=' . $grp['ID'] . sid() . '">';
				echo '<img ' . $IMG['edit'] . ' title="' . $T['change'] . '" />';
				echo '</a>';
			}
			echo '</td>';

			echo '</tr>';

			if ($grp['ID'] == $edit_grp)
			{
				if ($error) $grp = array(
					'Name' => $_POST['Name']
					);

				EditGroup($grp);
			}
		}
	}

	if ($add_grp == 1)
	{
		if ($error) $grp = array(
			'ID' => 0,
			'Name' => $_POST['Name']
			);
		else $grp = array(
			'ID' => 0,
			'Name' => ''
			);
		EditGroup($grp);
	}

	echo '</table>';
	echo '</p>';

	echo '<p>';
	echo '<a href="' . $ME . PD . 'tool=groups&amp;add=1' . sid() . '">' . $T['add_group'] . '</a>';
	if ($edit_grp) echo ' | <a href="' . $ME . PD . 'tool=groups' . sid() . '">' . $T['acl_cancel_edit'] . '</a>';
	else           echo ' | <a href="' . $ME . PD . 'tool=groups' . sid() . '">' . $T['acl_update_view'] . '</a>';
	echo '</p>';

	echo '<p>' . $T['grp_note'] . '</p>';

	echo '</form>';

	EndHTML();
}

if ($_REQUEST['tool'] == 'users')
{
	$user = new IUser;

	BeginHTML($T['inactive_users']);
	addlog("admin_users");

	if ($_REQUEST['action'] == 'RemoveUsers' && $_REQUEST['SureRemove'] == 1)
	{
		// Remove all selected users
		echo '<p>' . $T['removing_sel_users'] . '<br /><br />';
		foreach ($_REQUEST['uid'] as $uid)
		{
			if (!$user->Remove($uid)) echo str_replace('%n', $uid, $T['err_users_not_removed_n']) . '<br />';
			else echo str_replace('%n', $uid, $T['removed_user_n']) . '<br />';
		}
		echo '</p>';
	}

	// Create my own database object so that some function calls won't take away my result
	// and thus 'steal' all users after the 1st one!
	if (PHP5) eval('$mydb = clone $db;');
	else      $mydb = $db;

	// Find users without posts
	$pre = $mydb->tblprefix;
	$sql = "SELECT {$pre}Users.ID AS uid, COUNT({$pre}Posts.User) AS cnt " .
		"FROM {$pre}Users LEFT JOIN {$pre}Posts ON {$pre}Users.ID = {$pre}Posts.User " .
		"GROUP BY uid " .
		"HAVING cnt = 0";
	$mydb->Exec($sql);
	$posts = array();
	while ($record = $mydb->GetRecord())
	{
		array_push($posts, $record[0]);
	}
	if (sizeof($posts))
		$noposts = "OR (IF(LastActivity, LastActivity, RegDate) < " . (time() - 90 * 24 * 3600) . " AND ID IN (" . join(',', $posts) . ")) ";
	else
		$noposts = '';

	// Find users by
	// ... no group AND RegDate older than 30d
	// ... no post AND LastActivity older than 90d
	// ... others: LastActivity older than 360d
	$mydb->Exec("SELECT ID, {$pre}GroupMembers.Group " .
		"FROM {$pre}Users " .
			"LEFT JOIN {$pre}GroupMembers ON {$pre}Users.ID = {$pre}GroupMembers.User " .
		"WHERE (`Group` IS NULL AND RegDate < " . (time() - 30 * 24 * 3600) . ") " .
			$noposts .
			"OR (`Group` = 1 AND LastActivity < " . (time() - 360 * 24 * 3600) . ") " .
		"ORDER BY IF({$pre}Users.LastActivity, {$pre}Users.LastActivity, {$pre}Users.RegDate) ASC");

	$record = $mydb->GetRecord();

	echo '<p><b>' . $T['inactive_users'] . '</b></p>';

	if ($record)
	{
		echo '<form action="' . $ME . PD . 'tool=users' . sid() . '" method="post">';
		echo '<input type="hidden" name="action" value="RemoveUsers" />';

		echo '<table cellspacing="' . $TABLE['config']['space'] . '" cellpadding="' . $TABLE['config']['pad'] . '" border="' . $TABLE['config']['border'] .'" width="100%">';
		echo '<tr valign="top">';
		echo '<td class="list_config_head_left" width="19%">' . $T['username'] . '</td>';
		echo '<td class="list_config_head_0" width="23%">' . $T['registered_on'] . '</td>';
		echo '<td class="list_config_head_0" width="19%">' . $T['last_activity2'] . '</td>';
		echo '<td class="list_config_head_0" width="10%" align="center">' . $T['activated'] . '?</td>';
		echo '<td class="list_config_head_0" width="10%" align="center">' . $T['posts'] . '</td>';
		echo '<td class="list_config_head_right" width="19%" align="center">' . $T['remove_user'] . '?</td>';
		echo '</tr>';

		CountUserPosts();
		$view = 0;

		$group_names = GetGroupNames();

		do
		{
			$user->Load($record['ID']);

			echo '<tr>';

			echo '<td class="list_config_l">';
			echo MakeUserLink($user->GetID(),
				t2h($user->GetName()),
				true, false, false);
			echo '</td>';

			echo '<td class="list_config_l">';
			echo $T['member'] . ' ' . FriendlyDate($user->GetRegDate(), 2, 1, true, 1);
			echo '</td>';

			echo '<td class="list_config_l">';
			if (!$user->GetLastActivity()) echo $T['never'];
			else echo FriendlyDate($user->GetLastActivity(), 2, 1, true, 4);
			echo '</td>';

			echo '<td class="list_config_l" align="center">';
			if (!$record['Group']) echo '<span class="no">' . $T['no'] . '</span>';
			else echo '<span class="yes">' . $T['yes'] . '</span>';
			echo '</td>';

			echo '<td class="list_config_l" align="center">';
			echo GetPostsByUser($user->GetID());
			echo '</td>';

			echo '<td class="list_config_l" align="center">';
			echo '<input type="checkbox" class="radio" name="uid[]" value="' . $user->GetID() . '" />';
			echo '</td>';

			echo '</tr>';

			$count++;
		}
		while ($record = $mydb->GetRecord());
		$view = $count;

		echo '</table>';

		echo '<p>(' . $view . ' ' . ($view == 1 ? $T['user'] : $T['users']) . ')</p>';

		echo '<p>';
		echo '<input type="checkbox" class="radio" name="SureRemove" id="SureRemove" value="1" ' . suredelete() . ' /><label for="SureRemove">' . $T['sure_remove_users'] . '</label> &nbsp; &nbsp; ';
		echo '<input type="submit" class="button" name="Delete" value="' . $T['delete'] . '" />';
		echo '</p>';

		echo '</form>';
	}
	else
	{
		echo '<p>' . $T['no_inactive_users'] . '</p>';
	}

	EndHTML();
}

if ($_REQUEST['tool'] == 'log')
{
	BeginHTML($T['show_log']);
	addlog("admin_showlog");

	$date = $_REQUEST['logdate'];
	if ($date == '') $date = date("Y-m-d");

	function get_style($num)
	{
		switch ($num)
		{
			case  0: return 'color:#E00000;';
			case  1: return 'color:#00A000;';
			case  2: return 'color:#0000E0;';
			case  3: return 'color:#B0A000;';
			case  4: return 'color:#00A0F0;';
			case  5: return 'color:#C000C0;';
			case  6: return 'color:#FF5757;';
			case  7: return 'color:#00D600;';
			case  8: return 'color:#494DFF;';
			case  9: return 'color:#F300F6;';
			case 10: return 'color:#A40000;';
			case 11: return 'color:#007800;';
			case 12: return 'color:#00049C;';
			case 13: return 'color:#726900;';
			case 14: return 'color:#0075B2;';
			case 15: return 'color:#800082;';
			case 16: return 'color:#808080;';
			default: return 'color:#000000;';
		}
	}

	function make_filter($field, $str)
	{
		if (substr($str, 0, 2) === '<=') return array('field' => $field, 'op' => 1, 'value' => substr($str, 2));
		if (substr($str, 0, 2) === '>=') return array('field' => $field, 'op' => 2, 'value' => substr($str, 2));
		if (substr($str, 0, 2) === '!=') return array('field' => $field, 'op' => 3, 'value' => substr($str, 2));
		if (substr($str, 0, 1) === '<') return array('field' => $field, 'op' => 4, 'value' => substr($str, 1));
		if (substr($str, 0, 1) === '>') return array('field' => $field, 'op' => 5, 'value' => substr($str, 1));
		if (substr($str, 0, 1) === '=') return array('field' => $field, 'op' => 6, 'value' => substr($str, 1));
		if (substr($str, 0, 1) === '*') return array('field' => $field, 'op' => 7, 'value' => substr($str, 1));
		if (substr($str, 0, 1) === '^') return array('field' => $field, 'op' => 8, 'value' => substr($str, 1));
		else return array('field' => $field, 'op' => 7, 'value' => $str);
	}

	$showdate = $_REQUEST['showdate'] == 1;
	$showtime = $_REQUEST['showtime'] == 1;
	$showuserid = $_REQUEST['showuserid'] == 1;
	$showusername = $_REQUEST['showusername'] == 1;
	$showip = $_REQUEST['showip'] == 1;
	$showaction = $_REQUEST['showaction'] == 1;
	$showbrowser = $_REQUEST['showbrowser'] == 1;
	$showbver = $_REQUEST['showbver'] == 1;
	$showos = $_REQUEST['showos'] == 1;
	$showlang = $_REQUEST['showlang'] == 1;
	$showsess = $_REQUEST['showsess'] == 1;

	echo '<form action="' . $ME . '" method="get">';
	echo sid(4);
	echo '<input type="hidden" name="req" value="admin" />';
	echo '<input type="hidden" name="tool" value="log" />';

	echo '<p>';
	echo 'Log-Datum: <input type="text" class="text" name="logdate" size="13" value="' . htmlquote($date) . '" /> ';
	echo '<input type="submit" class="button" value="' . $T['update'] . '" /> ';

	$checked = $showdate ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showdate" id="showdate" value="1" ' . $checked . ' /><label for="showdate">' . $T['date'] . '</label> ';
	$checked = $showtime ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showtime" id="showtime" value="1" ' . $checked . ' /><label for="showtime">' . $T['time'] . '</label> ';
	$checked = $showuserid ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showuserid" id="showuserid" value="1" ' . $checked . ' /><label for="showuserid">' . $T['user_id'] . '</label> ';
	$checked = $showusername ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showusername" id="showusername" value="1" ' . $checked . ' /><label for="showusername">' . $T['username'] . '</label> ';
	$checked = $showip ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showip" id="showip" value="1" ' . $checked . ' /><label for="showip">' . $T['ip'] . '</label> ';
	$checked = $showaction ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showaction" id="showaction" value="1" ' . $checked . ' /><label for="showaction">' . $T['action'] . '</label> ';
	$checked = $showbrowser ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showbrowser" id="showbrowser" value="1" ' . $checked . ' /><label for="showbrowser">' . $T['browser'] . '</label> ';
	$checked = $showbver ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showbver" id="showbver" value="1" ' . $checked . ' /><label for="showbver">' . $T['version'] . '</label> ';
	$checked = $showos ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showos" id="showos" value="1" ' . $checked . ' /><label for="showos">' . $T['os'] . '</label> ';
	$checked = $showlang ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showlang" id="showlang" value="1" ' . $checked . ' /><label for="showlang">' . $T['lang'] . '</label> ';
	$checked = $showsess ? 'checked="checked"' : '';
	echo '<input type="checkbox" class="radio" name="showsess" id="showsess" value="1" ' . $checked . ' /><label for="showsess">' . $T['session'] . '</label> ';

	echo '</p>';

	echo '<table cellspacing="' . $TABLE['config']['space'] .'" cellpadding="' . $TABLE['config']['pad'] . '" border="' . $TABLE['config']['border'] . '" width="100%">';

	echo '<tr valign="top">';
	if ($showdate) echo '<td class="list_config_head_0">' . $T['date'] . '</td>';
	if ($showtime) echo '<td class="list_config_head_0">' . $T['time'] . '</td>';
	if ($showuserid) echo '<td class="list_config_head_0">' . $T['user_id'] . '</td>';
	if ($showusername) echo '<td class="list_config_head_0">' . $T['username'] . '</td>';
	if ($showip) echo '<td class="list_config_head_0">' . $T['ip'] . '</td>';
	if ($showaction) echo '<td class="list_config_head_0">' . $T['action'] . '</td>';
	if ($showbrowser) echo '<td class="list_config_head_0">' . $T['browser'] . '</td>';
	if ($showbver) echo '<td class="list_config_head_0">' . $T['version'] . '</td>';
	if ($showos) echo '<td class="list_config_head_0">' . $T['os'] . '</td>';
	if ($showlang) echo '<td class="list_config_head_0">' . $T['lang'] . '</td>';
	if ($showsess) echo '<td class="list_config_head_0">' . $T['session'] . '</td>';
	echo '</tr>';

	echo '<tr valign="top">';
	if ($showdate) echo '<td class="list_config_l"><input type="text" class="text" name="date" size="10" value="' . htmlquote($_REQUEST['date']) . '" /></td>';
	if ($showtime) echo '<td class="list_config_l"><input type="text" class="text" name="time" size="8" value="' . htmlquote($_REQUEST['time']) . '" /></td>';
	if ($showuserid) echo '<td class="list_config_l"><input type="text" class="text" name="userid" size="4" value="' . htmlquote($_REQUEST['userid']) . '" /></td>';
	if ($showusername) echo '<td class="list_config_l"><input type="text" class="text" name="username" size="10" value="' . htmlquote($_REQUEST['username']) . '" /></td>';
	if ($showip) echo '<td class="list_config_l"><input type="text" class="text" name="ip" size="12" value="' . htmlquote($_REQUEST['ip']) . '" /></td>';
	if ($showaction) echo '<td class="list_config_l"><input type="text" class="text" name="action" size="30" value="' . htmlquote($_REQUEST['action']) . '" /></td>';
	if ($showbrowser) echo '<td class="list_config_l"><input type="text" class="text" name="browser" size="5" value="' . htmlquote($_REQUEST['browser']) . '" /></td>';
	if ($showbver) echo '<td class="list_config_l"><input type="text" class="text" name="bver" size="3" value="' . htmlquote($_REQUEST['bver']) . '" /></td>';
	if ($showos) echo '<td class="list_config_l"><input type="text" class="text" name="os" size="3" value="' . htmlquote($_REQUEST['os']) . '" /></td>';
	if ($showlang) echo '<td class="list_config_l"><input type="text" class="text" name="lang" size="7" value="' . htmlquote($_REQUEST['lang']) . '" /></td>';
	if ($showsess) echo '<td class="list_config_l"><input type="text" class="text" name="sess" size="20" value="' . htmlquote($_REQUEST['sess']) . '" /></td>';
	echo '</tr>';

	$filters = array();
	if ($showdate) if ($_REQUEST['date'] != '') array_push($filters, make_filter('date', $_REQUEST['date']));
	if ($showtime) if ($_REQUEST['time'] != '') array_push($filters, make_filter('time', $_REQUEST['time']));
	if ($showuserid) if ($_REQUEST['userid'] != '') array_push($filters, make_filter('userid', $_REQUEST['userid']));
	if ($showusername) if ($_REQUEST['username'] != '') array_push($filters, make_filter('username', $_REQUEST['username']));
	if ($showip) if ($_REQUEST['ip'] != '') array_push($filters, make_filter('ip', $_REQUEST['ip']));
	if ($showaction) if ($_REQUEST['action'] != '') array_push($filters, make_filter('action', $_REQUEST['action']));
	if ($showbrowser) if ($_REQUEST['browser'] != '') array_push($filters, make_filter('browser', $_REQUEST['browser']));
	if ($showbver) if ($_REQUEST['bver'] != '') array_push($filters, make_filter('bver', $_REQUEST['bver']));
	if ($showos) if ($_REQUEST['os'] != '') array_push($filters, make_filter('os', $_REQUEST['os']));
	if ($showlang) if ($_REQUEST['lang'] != '') array_push($filters, make_filter('lang', $_REQUEST['lang']));
	if ($showsess) if ($_REQUEST['sess'] != '') array_push($filters, make_filter('sess', $_REQUEST['sess']));

	$userids = array();
	$usernames = array();
	$ips = array();
	$browsers = array();
	$bvers = array();
	$oss = array();
	$langs = array();
	$sesss = array();

	$php430 = phpversion() >= '4.3.0';
	$fp = @fopen($logpath . "board-$date.log", 'r');
	if ($fp) while (!feof($fp))
	{
		if ($php430)
			$fields = fgetcsv($fp, 1024, ' ', '"');
		else
		{
			$fields = explode_quoted(' ', trim(fgets($fp, 1024)));
		}
		list($entry['date'],
			$entry['time'],
			$entry['userid'],
			$entry['username'],
			$entry['ip'],
			$entry['action'],
			$entry['browser'],
			$entry['bver'],
			$entry['os'],
			$entry['lang'],
			$entry['sess']) = $fields;
		if (!$entry['date']) continue;

		$ok = true;
		foreach ($filters as $filter)
		{
			if ($filter['op'] === 4)
			{
				if (!($entry[$filter['field']] < $filter['value'])) $ok = false;
			}
			elseif ($filter['op'] === 5)
			{
				if (!($entry[$filter['field']] > $filter['value'])) $ok = false;
			}
			elseif ($filter['op'] === 1)
			{
				if (!($entry[$filter['field']] <= $filter['value'])) $ok = false;
			}
			elseif ($filter['op'] === 2)
			{
				if (!($entry[$filter['field']] >= $filter['value'])) $ok = false;
			}
			elseif ($filter['op'] === 6)
			{
				if (!($entry[$filter['field']] === $filter['value'] ||
					!strcasecmp($entry[$filter['field']], $filter['value']))) $ok = false;
			}
			elseif ($filter['op'] === 3)
			{
				if (!($entry[$filter['field']] != $filter['value'])) $ok = false;
			}
			elseif ($filter['op'] === 7)
			{
				if (!($entry[$filter['field']] === $filter['value'] ||
					  stristr($entry[$filter['field']], $filter['value']))) $ok = false;
			}
			elseif ($filter['op'] === 8)
			{
				if (strncasecmp($entry[$filter['field']], $filter['value'], strlen($filter['value']))) $ok = false;
			}
		}
		if (!$ok && $filters) continue;

		if (!in_array($entry['userid'], $userids)) array_push($userids, $entry['userid']);
		$userid_style = get_style(array_search($entry['userid'], $userids, true));
		if (!in_array($entry['username'], $usernames)) array_push($usernames, $entry['username']);
		$username_style = get_style(array_search($entry['username'], $usernames, true));
		if (!in_array($entry['ip'], $ips)) array_push($ips, $entry['ip']);
		$ip_style = get_style(array_search($entry['ip'], $ips, true));
		if (!in_array($entry['browser'], $browsers)) array_push($browsers, $entry['browser']);
		$browser_style = get_style(array_search($entry['browser'], $browsers, true));
		if (!in_array($entry['bver'], $bvers)) array_push($bvers, $entry['bver']);
		$bver_style = get_style(array_search($entry['bver'], $bvers, true));
		if (!in_array($entry['os'], $oss)) array_push($oss, $entry['os']);
		$os_style = get_style(array_search($entry['os'], $oss, true));
		if (!in_array($entry['lang'], $langs)) array_push($langs, $entry['lang']);
		$lang_style = get_style(array_search($entry['lang'], $langs, true));
		if (!in_array($entry['sess'], $sesss)) array_push($sesss, $entry['sess']);
		$sess_style = get_style(array_search($entry['sess'], $sesss, true));

		echo '<tr valign="top" onmouseover="this.className=\'tr_hover\'" onmouseout="this.className=\'\'">';
		if ($showdate) echo '<td class="list_config_l">' . $entry['date'] . '</td>';
		if ($showtime) echo '<td class="list_config_l">' . $entry['time'] . '</td>';
		if ($showuserid) echo '<td class="list_config_l" style="' . $userid_style . '">' . $entry['userid'] . '</td>';
		if ($showusername)
		{
			$username = $entry['username'];
			if ($entry['userid'] != 0)
				echo '<td class="list_config_l"><a style="' . $username_style . '" href="' . $MODULE['cp'] . PD . 'id=' . $entry['userid'] . sid() . '">' . $username . '</a></td>';
			else
				echo '<td class="list_config_l" style="' . $username_style . '">' . $username . '</td>';
		}
		if ($showip) echo '<td class="list_config_l" style="' . $ip_style . '">' . $entry['ip'] . '</td>';
		if ($showaction)
		{
			$action = stripslashes($entry['action']);
			#$action = $entry['action'];
			$action = preg_replace("/^view_forum (\d+)/",
				'view_forum <a href="' . $MODULE['main'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^view_thread (\d+)/",
				'view_thread <a href="' . $MODULE['thread'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^add_post (\d+) to (\d+) ok/e",
				'\'<i>add_post</i> \' . MakePostLink(intval(\'$1\'),0,0,true) . \'$1</a> to <a href="\' . $MODULE[\'thread\'] . PD . \'id=$2">$2</a> ok\'', $action);
			$action = preg_replace("/^preview_post in (\d+)/",
				'view_thread <a href="' . $MODULE['thread'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^add_message to (\d+) ok/",
				'<i>add_message</i> to <a href="' . $MODULE['main'] . PD . 'id=$1">$1</a> ok', $action);
			$action = preg_replace("/^view_profile (\d+)/",
				'view_profile <a href="' . $MODULE['cp'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^edit_profile (\d+)/",
				'<i>edit_profile</i> <a href="' . $MODULE['cp'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^email_user (\d+)/",
				'email_user <a href="' . $MODULE['cp'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^add_user (\d+)/",
				'<i>add_user</i> <a href="' . $MODULE['cp'] . PD . 'id=$1">$1</a>', $action);
			$action = preg_replace("/^goto_url (.+)/e",
				'\'goto_url <a href="\' . $MODULE[\'derefer\'] . PD . \'url=\' . urlencode(stripslashes(\'$1\')) . \'">$1</a>\'', $action);
			$action = preg_replace("/^add_forum (\d+) ok/",
				'<i>add_forum</i> <a href="' . $MODULE['main'] . PD . 'id=$1">$1</a> ok', $action);
			$action = preg_replace("/^(remove_user|remove_post|remove_forum|message_read|message_unread|all_threads_read|all_forums_read)/",
				'<i>$1</i>', $action);

			echo '<td class="list_config_l">' . $action . '</td>';
		}
		if ($showbrowser) echo '<td class="list_config_l" style="' . $browser_style . '">' . $entry['browser'] . '</td>';
		if ($showbver) echo '<td class="list_config_l" style="' . $bver_style . '">' . $entry['bver'] . '</td>';
		if ($showos) echo '<td class="list_config_l" style="' . $os_style . '">' . $entry['os'] . '</td>';
		if ($showlang) echo '<td class="list_config_l" style="' . $lang_style . '">' . $entry['lang'] . '</td>';
		if ($showsess) echo '<td class="list_config_l" style="' . $sess_style . '">' . $entry['sess'] . '</td>';
		echo '</tr>';
	}

	echo '</table>';
	echo '</form>';

	EndHTML();
}

?>
