<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// checkdb.php
// Database Integrity Check

$action = $_REQUEST['action'];
if (!$action) $action = 'check';

@set_time_limit(0);

require($libpath . 'lang/' . $LANG . '_more.php');

if (!CheckRights('is_admin'))
{
	errorlog("access denied");
	die($T['err_access_denied']);
}

BeginHTML('Database Integrity Check');

$pre = $db->tblprefix;

if ($action == 'check')
{
	echo '<p>Running entire database check...</p>';
	echo '<div>';

	// ACL.Forum IN [0, Forums.ID]
	$db->Exec("SELECT {$pre}ACL.* FROM {$pre}ACL LEFT JOIN {$pre}Forums ON {$pre}ACL.Forum = {$pre}Forums.ID " .
		"WHERE {$pre}ACL.Forum <> 0 AND {$pre}Forums.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'ACL ' . $rec['ID'] . ' has an invalid forum reference to ' . $rec['Forum'] . '<br />';
	}

	// ACL.Thread IN [0, Threads.ID]
	$db->Exec("SELECT {$pre}ACL.* FROM {$pre}ACL LEFT JOIN {$pre}Threads ON {$pre}ACL.Thread = {$pre}Threads.ID " .
		"WHERE {$pre}ACL.Thread <> 0 AND {$pre}Threads.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'ACL ' . $rec['ID'] . ' has an invalid topic reference to ' . $rec['Thread'] . '<br />';
	}

	// ACL.Group IN [0, GroupNames.ID]
	$db->Exec("SELECT {$pre}ACL.* FROM {$pre}ACL LEFT JOIN {$pre}GroupNames ON {$pre}ACL.Group = {$pre}GroupNames.ID " .
		"WHERE {$pre}ACL.Group <> 0 AND {$pre}GroupNames.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'ACL ' . $rec['ID'] . ' has an invalid user group reference to ' . $rec['Group'] . '<br />';
	}

	// ACL.User IN [0, Users.ID]
	$db->Exec("SELECT {$pre}ACL.* FROM {$pre}ACL LEFT JOIN {$pre}Users ON {$pre}ACL.User = {$pre}Users.ID " .
		"WHERE {$pre}ACL.User <> 0 AND {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'ACL ' . $rec['ID'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// ForumWatch.Forum IN Forums.ID
	$db->Exec("SELECT {$pre}ForumWatch.* FROM {$pre}ForumWatch LEFT JOIN {$pre}Forums ON {$pre}ForumWatch.Forum = {$pre}Forums.ID " .
		"WHERE {$pre}Forums.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Forum notification for user ' . $rec['User'] . ' and forum ' . $rec['Forum'] . ' has an invalid forum reference to ' . $rec['Forum'] . '<br />';
	}

	// ForumWatch.User in Users.ID
	$db->Exec("SELECT {$pre}ForumWatch.* FROM {$pre}ForumWatch LEFT JOIN {$pre}Users ON {$pre}ForumWatch.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Forum notification for user ' . $rec['User'] . ' and forum ' . $rec['Forum'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// Forums.Parent IN [0, Forums.ID] -- no cycles allowed
	$db->Exec("SELECT f1.* FROM {$pre}Forums f1 LEFT JOIN {$pre}Forums f2 ON f1.Parent = f2.ID " .
		"WHERE f2.Parent <> 0 AND f2.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['main'] . PD . 'id=' . $rec['ID'] . sid() . '">Forum ' . $rec['ID'] . '</a> has an invalid parent reference to ' . $rec['Parent'] . '<br />';
	}
	// TODO: check for cycles here

	// Forums.Name NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Forums " .
		"WHERE TRIM(Name) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['main'] . PD . 'id=' . $rec['ID'] . sid() . '">Forum ' . $rec['ID'] . '</a> has an empty name<br />';
	}

	// GroupMembers.Group IN GroupNames.ID
	$db->Exec("SELECT {$pre}GroupMembers.* FROM {$pre}GroupMembers LEFT JOIN {$pre}GroupNames ON {$pre}GroupMembers.Group = {$pre}GroupNames.ID " .
		"WHERE {$pre}GroupNames.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Group membership for user ' . $rec['User'] . ' and group ' . $rec['Group'] . ' has an invalid group reference to ' . $rec['Group'] . '<br />';
	}

	// GroupMembers.User IN Users.ID
	$db->Exec("SELECT {$pre}GroupMembers.* FROM {$pre}GroupMembers LEFT JOIN {$pre}Users ON {$pre}GroupMembers.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Group membership for user ' . $rec['User'] . ' and group ' . $rec['Group'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// GroupNames.Name NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}GroupNames " .
		"WHERE TRIM(Name) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Group ' . $rec['ID'] . ' has an empty name<br />';
	}

	// MessageRead.Msg IN Messages.ID
	$db->Exec("SELECT {$pre}MessageRead.* FROM {$pre}MessageRead LEFT JOIN {$pre}Messages ON {$pre}MessageRead.Msg = {$pre}Messages.ID " .
		"WHERE {$pre}Messages.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'MessageRead for user ' . $rec['User'] . ' and message ' . $rec['Msg'] . ' has an invalid message reference to ' . $rec['Msg'] . '<br />';
	}

	// MessageRead.User IN Users.ID
	$db->Exec("SELECT {$pre}MessageRead.* FROM {$pre}MessageRead LEFT JOIN {$pre}Users ON {$pre}MessageRead.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'MessageRead for user ' . $rec['User'] . ' and message ' . $rec['Msg'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// Messages.Forum IN [-1, 0, Forums.ID]
	$db->Exec("SELECT {$pre}Messages.* FROM {$pre}Messages LEFT JOIN {$pre}Forums ON {$pre}Messages.Forum = {$pre}Forums.ID " .
		"WHERE {$pre}Messages.Forum <> -1 AND {$pre}Messages.Forum <> 0 AND {$pre}Forums.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Message ' . $rec['ID'] . ' has an invalid forum reference to ' . $rec['Forum'] . '<br />';
	}

	// Messages.User IN Users.ID
	$db->Exec("SELECT {$pre}Messages.* FROM {$pre}Messages LEFT JOIN {$pre}Users ON {$pre}Messages.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['main'] . PD . 'id=' . $rec['Forum'] . sid() . '">Message ' . $rec['ID'] . '</a> has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// Messages.Msg NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Messages " .
		"WHERE TRIM(Msg) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['main'] . PD . 'id=' . $rec['Forum'] . sid() . '">Message ' . $rec['ID'] . '</a> has an empty content<br />';
	}

	// PollUsers.Thread IN Threads.ID WHERE Threads.Options & 4
	$db->Exec("SELECT {$pre}PollUsers.* FROM {$pre}PollUsers LEFT JOIN {$pre}Threads ON {$pre}PollUsers.Thread = {$pre}Threads.ID " .
		"WHERE NOT ({$pre}Threads.Options & 4) OR {$pre}Threads.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'User vote for user ' . $rec['User'] . ' and thread ' . $rec['Thread'] . ' has an invalid thread reference to ' . $rec['Thread'] . '<br />';
	}

	// PollUsers.User IN Users.ID
	$db->Exec("SELECT {$pre}PollUsers.* FROM {$pre}PollUsers LEFT JOIN {$pre}Users ON {$pre}PollUsers.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'User vote for user ' . $rec['User'] . ' and thread ' . $rec['Thread'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// PollUsers.VoteNum IN [0, PollVotes.ID]
	$db->Exec("SELECT {$pre}PollUsers.* FROM {$pre}PollUsers LEFT JOIN {$pre}PollVotes ON {$pre}PollUsers.VoteNum = {$pre}PollVotes.ID " .
		"WHERE {$pre}PollUsers.VoteNum <> 0 AND {$pre}PollVotes.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'User vote for user ' . $rec['User'] . ' and thread ' . $rec['Thread'] . ' has an invalid vote reference to ' . $rec['VoteNum'] . '<br />';
	}

	// PollVotes.Thread IN Threads.ID WHERE Threads.Options & 4
	$db->Exec("SELECT {$pre}PollVotes.* FROM {$pre}PollVotes LEFT JOIN {$pre}Threads ON {$pre}PollVotes.Thread = {$pre}Threads.ID " .
		"WHERE NOT ({$pre}Threads.Options & 4) OR {$pre}Threads.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Vote ' . $rec['ID'] . ' has an invalid thread reference to ' . $rec['Thread'] . '<br />';
	}

	// PollVotes.Title NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}PollVotes " .
		"WHERE TRIM(Title) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['Thread'] . sid() . '">Vote ' . $rec['ID'] . '</a> has an empty title<br />';
	}

	// Posts.Thread IN Threads.ID
	$db->Exec("SELECT {$pre}Posts.* FROM {$pre}Posts LEFT JOIN {$pre}Threads ON {$pre}Posts.Thread = {$pre}Threads.ID " .
		"WHERE {$pre}Threads.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Post ' . $rec['ID'] . ' has an invalid thread reference to ' . $rec['Thread'] . '<br />';
	}

	// Posts.ReplyTo IN [0, Posts.ID WHERE Thread = this:Posts.Thread] AND NOT this:Posts.ID
	$db->Exec("SELECT p1.* " .
		"FROM {$pre}Posts p1 LEFT JOIN {$pre}Posts p2 " .
			"ON p1.ReplyTo = p2.ID AND p1.Thread = p2.Thread AND p1.ID <> p2.ID " .
		"WHERE p1.ReplyTo <> 0 AND p2.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has an invalid replyto reference to ' . $rec['ReplyTo'] . '<br />';
	}

	// Posts.EditUser IN [-1, 0, Users.ID]
	$db->Exec("SELECT {$pre}Posts.* FROM {$pre}Posts LEFT JOIN {$pre}Users ON {$pre}Posts.EditUser = {$pre}Users.ID " .
		"WHERE {$pre}Posts.EditUser <> -1 AND {$pre}Posts.EditUser <> 0 AND {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has an invalid edit user reference to ' . $rec['EditUser'] . '<br />';
	}

	// Posts.EditDate > this:Posts.Date
	$db->Exec("SELECT * FROM {$pre}Posts " .
		"WHERE EditDate <> 0 AND EditDate < Date");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has an invalid edit date (less than post date)<br />';
	}

	// IF Posts.EditCount = 0 THEN Posts.EditDate = 0 AND Posts.EditUser = 0
	$db->Exec("SELECT * FROM {$pre}Posts " .
		"WHERE EditCount = 0 AND (EditDate <> 0 OR EditUser <> 0)");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has invalid edit date or user (but was never edited)<br />';
	}

	// IF Posts.AttachFile = '' THEN Posts.AttachFileName = '' AND Posts.AttachDLCount = 0
	$db->Exec("SELECT * FROM {$pre}Posts " .
		"WHERE AttachFile = '' AND (AttachFileName <> '' OR AttachDLCount > 0)");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has invalid attachment data (but has no attachment assigned)<br />';
	}

	// Posts.User IN [-1, 0, Users.ID]
	$db->Exec("SELECT {$pre}Posts.* FROM {$pre}Posts LEFT JOIN {$pre}Users ON {$pre}Posts.User = {$pre}Users.ID " .
		"WHERE {$pre}Posts.User <> -1 AND {$pre}Posts.User <> 0 AND {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// IF Posts.User <= 0 THEN Posts.UserName NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Posts " .
		"WHERE User <= 0 AND TRIM(UserName) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has an empty username and no user ID<br />';
	}

	// Posts.Msg NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Posts " .
		"WHERE TRIM(Msg) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo MakePostLink(intval($rec['ID']), 0, 0, true) . 'Post ' . $rec['ID'] . '</a> has an empty content<br />';
	}

	// ThreadWatch.Thread IN Threads.ID
	$db->Exec("SELECT {$pre}ThreadWatch.* FROM {$pre}ThreadWatch LEFT JOIN {$pre}Threads ON {$pre}ThreadWatch.Thread = {$pre}Threads.ID " .
		"WHERE {$pre}Threads.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Thread notification for user ' . $rec['User'] . ' and thread ' . $rec['Thread'] . ' has an invalid thread reference to ' . $rec['Thread'] . '<br />';
	}

	// ThreadWatch.User IN Users.ID
	$db->Exec("SELECT {$pre}ThreadWatch.* FROM {$pre}ThreadWatch LEFT JOIN {$pre}Users ON {$pre}ThreadWatch.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'Thread notification for user ' . $rec['User'] . ' and thread ' . $rec['Thread'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// Threads.Forum IN Forums.ID WHERE NOT (Forums.Flags & 1 OR Forums.Flags & 2)
	$db->Exec("SELECT {$pre}Threads.* FROM {$pre}Threads LEFT JOIN {$pre}Forums ON {$pre}Threads.Forum = {$pre}Forums.ID AND NOT ({$pre}Forums.Flags & 3)" .
		"WHERE {$pre}Forums.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has an invalid forum reference to ' . $rec['Forum'] . '<br />';
	}

	// Threads.Subject NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Threads " .
		"WHERE TRIM(Subject) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has an empty subject<br />';
	}

	// Threads.User IN [-1, 0, Users.ID]
	$db->Exec("SELECT {$pre}Threads.* FROM {$pre}Threads LEFT JOIN {$pre}Users ON {$pre}Threads.User = {$pre}Users.ID " .
		"WHERE {$pre}Threads.User <> -1 AND {$pre}Threads.User <> 0 AND {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// IF Threads.User <= 0 THEN Threads.UserName NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Threads " .
		"WHERE User <= 0 AND TRIM(UserName) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has an empty username and no user ID<br />';
	}

	// IF Threads.Options & 4 THEN Threads.Question NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Threads " .
		"WHERE (Options & 4) AND TRIM(Question) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> is a poll and has an empty question<br />';
	}

	// Moved threads must point to a valid thread other than themselves
	// IF Threads.Options & 8 THEN Threads.Question IN Threads.ID AND NOT this:Threads.ID
	$db->Exec("SELECT t1.* " .
		"FROM {$pre}Threads t1 " .
			"LEFT JOIN {$pre}Threads t2 ON t1.Question = t2.ID " .
		"WHERE (t1.Options & 8) AND (t1.Question = t1.ID OR t2.ID IS NULL)");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['main'] . PD . 'id=' . $rec['Forum'] . sid() . '">Thread ' . $rec['ID'] . '</a> is a moved note and has an invalid target thread reference to ' . $rec['Question'] . '<br />';
	}

	// UserCategoryState.Forum IN Forums.ID
	$db->Exec("SELECT {$pre}UserCategoryState.* FROM {$pre}UserCategoryState LEFT JOIN {$pre}Forums ON {$pre}UserCategoryState.Forum = {$pre}Forums.ID " .
		"WHERE {$pre}Forums.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'UserCategoryState for user ' . $rec['User'] . ' and forum ' . $rec['Forum'] . ' has an invalid forum reference to ' . $rec['Forum'] . '<br />';
	}

	// UserCategoryState.User IN Users.ID
	$db->Exec("SELECT {$pre}UserCategoryState.* FROM {$pre}UserCategoryState LEFT JOIN {$pre}Users ON {$pre}UserCategoryState.User = {$pre}Users.ID " .
		"WHERE {$pre}Users.ID IS NULL");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo 'UserCategoryState for user ' . $rec['User'] . ' and forum ' . $rec['Forum'] . ' has an invalid user reference to ' . $rec['User'] . '<br />';
	}

	// Users.Name NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Users " .
		"WHERE TRIM(Name) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['cp'] . PD . 'id=' . $rec['ID'] . sid() . '">User ' . $rec['ID'] . '</a> has an empty name<br />';
	}

	// Users.Password NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Users " .
		"WHERE TRIM(Password) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['cp'] . PD . 'id=' . $rec['ID'] . sid() . '">User ' . $rec['ID'] . '</a> has an empty password<br />';
	}

	// Users.RegEMail NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Users " .
		"WHERE TRIM(RegEMail) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['cp'] . PD . 'id=' . $rec['ID'] . sid() . '">User ' . $rec['ID'] . '</a> has an empty registration e-mail address<br />';
	}

	// Users.EMail NOT EMPTY
	$db->Exec("SELECT * FROM {$pre}Users " .
		"WHERE TRIM(EMail) = ''");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['cp'] . PD . 'id=' . $rec['ID'] . sid() . '">User ' . $rec['ID'] . '</a> has an empty e-mail address<br />';
	}

	// All Threads [that are not moved] must have at least one post
	$db->Exec("SELECT {$pre}Threads.*, COUNT({$pre}Posts.ID) AS PostsCount " .
		"FROM {$pre}Threads LEFT JOIN {$pre}Posts ON {$pre}Threads.ID = {$pre}Posts.Thread " .
		"WHERE NOT ({$pre}Threads.Options & 8) " .
		"GROUP BY {$pre}Threads.ID " .
		"HAVING PostsCount = 0");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has no posts<br />';
	}

	// All polls must have at least one vote [reply option]
	$db->Exec("SELECT {$pre}Threads.*, COUNT({$pre}PollVotes.ID) AS VotesCount " .
		"FROM {$pre}Threads LEFT JOIN {$pre}PollVotes " .
			"ON {$pre}Threads.ID = {$pre}PollVotes.Thread " .
		"WHERE {$pre}Threads.Options & 4 AND NOT ({$pre}Threads.Options & 8) " .
		"GROUP BY {$pre}Threads.ID " .
		"HAVING VotesCount = 0");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> is a poll and has no PollVotes (reply options)<br />';
	}

	// All Threads.LastPostDate must be the Posts.Date of the last post in this thread
	$db->Exec("SELECT {$pre}Threads.*, MAX({$pre}Posts.Date) AS MaxDate " .
		"FROM {$pre}Threads " .
			"LEFT JOIN {$pre}Posts ON {$pre}Threads.ID = {$pre}Posts.Thread " .
		"WHERE NOT ({$pre}Threads.Options & 8) " .
		"GROUP BY {$pre}Threads.ID " .
		"HAVING LastPostDate <> MaxDate");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has an invalid LastPostDate value [<a href="' . $ME . PD . 'action=repair_lastpostdate' . sid() . '">repair</a>]<br />';
	}

	// All threads of which posts have an attachment must have flag 16 (attachments), others must not
	$db->Exec("SELECT {$pre}Threads.*, CASE MAX(LENGTH({$pre}Posts.AttachFile)) WHEN 0 THEN 0 ELSE 16 END AS MaxLenAttach " .
		"FROM {$pre}Threads " .
			"LEFT JOIN {$pre}Posts ON {$pre}Threads.ID = {$pre}Posts.Thread " .
		"WHERE NOT ({$pre}Threads.Options & 8) " .
		"GROUP BY {$pre}Threads.ID " .
		"HAVING (Options & 16) <> MaxLenAttach");
	echo t2h($db->LastError());
	while ($rec = $db->GetRecord())
	{
		echo '<a href="' . $MODULE['thread'] . PD . 'id=' . $rec['ID'] . sid() . '">Thread ' . $rec['ID'] . '</a> has an invalid attachment flag value [<a href="' . $ME . PD . 'action=repair_threadattach' . sid() . '">repair</a>]<br />';
	}

	echo '</div>';
	echo '<p>Check finished.</p>';
}  // if action == 'check'

if ($action == 'repair_lastpostdate')
{
	echo '<p>Repairing threads\' LastPostDate...</p>';

	// Set correct LastPostDate for all threads
	$thread = new IThread;
	if ($thread->Find()) do
	{
		$record = GetLastPost($thread->GetID());
		$thread->SetLastPostDate($record['Date']);
	}
	while ($thread->FindNext());

	echo '<p>Repair finished. [<a href="' . $ME . PD . 'action=check' . sid() . '">check again</a>]</p>';
}

if ($action == 'repair_threadattach')
{
	echo '<p>Repairing threads\' attachment flag...</p>';

	// Add thread-has-attachment flags
	$thread = new IThread;
	$thread2 = new IThread;
	$post = new IPost;
	if ($thread->Find()) do
	{
		$found = $post->Find('Thread=' . $thread->GetID() . " AND AttachFile<>''", '', 1);

		$opt = $thread->GetOptions();
		$opt = ($opt & ~16) | (($found ? 1 : 0) * 16);
		$thread2->SetOptions($opt, $thread->GetID());   // no error detection here
	}
	while ($thread->FindNext());

	echo '<p>Repair finished. [<a href="' . $ME . PD . 'action=check' . sid() . '">check again</a>]</p>';
}

EndHTML(true);

?>