<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// ABBC help page language resource file
//
// Language : English (en)
// Encoding : UTF-8 (without encoding marker at file begin!)
// Author   : Yves Goergen <contact@unclassified.de>
// Last edit: 20040531
?>

<p>
<b>Advanced BBCode</b> is a markup language you can easy format postings with. There are the following tags for that, among others:
</p>

<div class=help_entry>
<div class=keyword>Text formatting</div>
<div class=content>
	[b]...[/b] &nbsp; Bold, or: &nbsp; *Bold*<br />
	[i]...[/i] &nbsp; Italic, or: &nbsp; /Italic/<br />
	[u]...[/u] &nbsp; Underline, or: &nbsp; _Under_<br />
	[s]...[/s] &nbsp; Strike out, or: &nbsp; ~Strike~<br />
	[o]...[/o] &nbsp; Overline<br />
	[m]...[/m] &nbsp; Fixed width<br /><br />

	The alternative special codes may cause display problems. In this case you can select the "<?= $T['no_special_abbc_syntax'] ?>" option to not apply these codes to a posting.
</div>
</div>

<div class=help_entry>
<div class=keyword>Font appearance</div>
<div class=content>
	[font=<i>xxx</i>]...[/font] &nbsp; Font family <i>xxx</i><br />
	[font=<i>xxx</i>:<i>n</i>]...[/font] &nbsp; Font family <i>xxx</i>, size <i>n</i> px<br />
	[size=<i>n</i>]...[/size] &nbsp; Size <i>n</i> px<br />
	&nbsp; &nbsp; <i>Conversion pt &lt;-&gt; px see below</i><br />
	[color=<i>xxx</i>]...[/color] &nbsp; Text colour <i>xxx</i> (#RRGGBB)<br />
	[mark=<i>xxx</i>]...[/mark] &nbsp; Background colour <i>xxx</i><br />
	[sup]...[/sup] &nbsp; Superscript text<br />
	[sub]...[/sub] &nbsp; Subscript text<br />
	[align=<i>xxx</i>]...[/align] &nbsp; Text alignment: left/center/right/justify<br />
</div>
</div>

<div class=help_entry>
<div class=keyword>Lists</div>
<div class=content>
	[list]<br />
	[*] ... &nbsp; Enumeration item<br />
	[/list]<br />
	Different list types: &nbsp; [list=<i>xxx</i>] &nbsp; 1/A/i/a/o/+<br /><br />

	Simple lists: &nbsp; */o/# at the beginning of a line (without [list])<br />
	&nbsp; &nbsp; <i>(see note on the Basic Formatting above)</i>
</div>
</div>

<div class=help_entry>
<div class=keyword>Images and links</div>
<div class=content>
	[img]...[/img] &nbsp; Display image ...<br />
	[img=<i>align</i>]...[/img] &nbsp; Image with alignment: left/right/middle...<br />
	[url]...[/url] &nbsp; Link to ...<br />
	[mail]...[/mail] &nbsp; E-Mail to ...<br />
</div>
</div>

<div class=help_entry>
<div class=keyword>Code and Quotations</div>
<div class=content>
	[code]...[/code] &nbsp; Source code<br />
	[code=php]...[/code] &nbsp; Source code with PHP syntax<br />
	[quote]...[/quote] &nbsp; Quotation<br />
	[quote=<i>xxx</i>]...[/quote] &nbsp; Quotation by <i>xxx</i><br />
	[indent]...[/indent] &nbsp; Indent text block<br />
	[indent=<i>n</i>]...[/indent] &nbsp; Indent text block by <i>n</i> pixels<br /><br />

	Simple quotations: &nbsp; |" ... "|<br />
	&nbsp; &nbsp; <i>(see note on the Basic Formatting above)</i><br /><br />

	You can enable syntax highlighting with [code] tags by specifying a language name as parameter. Currently the following languages are supported:<br />
	PHP (PHP native function), C (still buggy)
</div>
</div>

<div class=help_entry>
<div class=keyword>Miscellaneous</div>
<div class=content>
	[line] &nbsp; Horizontal line, or: &nbsp; ---- (at least 4 dashes)<br />
	[line=<i>color</i>] &nbsp; Line with colour <i>color</i><br />
	[line=<i>color</i>:<i>size</i>] &nbsp; Line with colour <i>color</i> and width <i>size</i><br />
</div>
</div>

<p>
Anything in between [#] and [/#] will not be evaluated or changed in any way. Single tags can be masked by writing \[ for a [. [rem]...[/rem] are comments that will not be displayed at all.
</p>

<p>
Line breaks surrounding tags that make a paragraph of their own (i.e. [code], [quote], [align], [line]) will be removed. Also if the [code] tag stands in a line for its own, no new lines will be displayed around it.
</p>

<p>
This table shows conversion of font sizes between pt (point) and px (pixels):<br />
&nbsp; 7pt -- 9px<br />
&nbsp; 8pt -- 11px<br />
&nbsp; 10pt -- 13px<br />
&nbsp; 12pt -- 16px<br />
&nbsp; 14pt -- 19px<br />
</p>

<p>
<i>To familiarise yourself with these conventions, you should use the <b>Preview</b> at first, to check your submission.</i>
</p>

<p>
ESC (Escape) closes this window.
</p>

<p>
<small>You'll find more information about the ABBC parser and its language on the <a href="<?= $MODULE['derefer'] . PD ?>url=http://software.unclassified.de/abbc" target=_blank>ABBC homepage</a>.</small>
</p>
