<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// ABBC help page language resource file
//
// Language : Dutch (nl)
// Encoding : UTF-8 (without encoding marker at file begin!)
// Author   : Ben Branders, jabberweb.be
// Last edit: 20040531
?>

<p>
<b>Gevorderde BBCode</b> is een opmaaktaal waarmee je gemakkelijk je berichten kan opmaken. Voor dat doel bestaan er onder andere de volgende tags:
</p>

<div class=help_entry>
<div class=keyword>Tekstopmaak</div>
<div class=content>
	[b]...[/b] &nbsp; vet, of: &nbsp; *Vet*<br />
	[i]...[/i] &nbsp; cursief, of: &nbsp; /Cursief/<br />
	[u]...[/u] &nbsp; onderlijnen, of: &nbsp; _Onder_<br />
	[s]...[/s] &nbsp; doorstrepen, of: &nbsp; ~Streep~<br />
	[o]...[/o] &nbsp; bovenlijn<br />
	[m]...[/m] &nbsp; vaste breedte<br /><br />

	De alternatieve speciale codes kunnen problemen veroorzaken. In dit geval kan je de "<?= $T['no_special_abbc_syntax'] ?>" optie selecteren om deze codes niet toe te passen in je bericht.
</div>
</div>

<div class=help_entry>
<div class=keyword>Lettertype</div>
<div class=content>
	[font=<i>xxx</i>]...[/font] &nbsp; Lettertypefamilie <i>xxx</i><br />
	[font=<i>xxx</i>:<i>n</i>]...[/font] &nbsp; Lettertypefamilie <i>xxx</i>, grootte <i>n</i> px<br />
	[size=<i>n</i>]...[/size] &nbsp; Grootte <i>n</i> px<br />
	&nbsp; &nbsp; <i>Omzetting pt &lt;-&gt; px zie onderaan</i><br />
	[color=<i>xxx</i>]...[/color] &nbsp; Tekstkleur <i>xxx</i> (#RRGGBB)<br />
	[mark=<i>xxx</i>]...[/mark] &nbsp; Achtergrondkleur <i>xxx</i><br />
	[sup]...[/sup] &nbsp; Superscript tekst<br />
	[sub]...[/sub] &nbsp; Subscript tekst<br />
	[align=<i>xxx</i>]...[/align] &nbsp; Tekst uitlijning: left/center/right/justify<br />
</div>
</div>

<div class=help_entry>
<div class=keyword>Lijsten</div>
<div class=content>
	[list]<br />
	[*] ... &nbsp; Opsommingsitem<br />
	[/list]<br />
	Verschillende lijsttypes: &nbsp; [list=<i>xxx</i>] &nbsp; 1/A/i/a/o/+<br /><br />

	Eenvoudige lijsten: &nbsp; */o/# aan het begin van een lijn (zonder [list])<br />
	&nbsp; &nbsp; <i>(zie bovenstaande nota over de Basisopmaak)</i>
</div>
</div>

<div class=help_entry>
<div class=keyword>Afbeeldingen en links</div>
<div class=content>
	[img]...[/img] &nbsp; Toon afbeelding ...<br />
	[img=<i>align</i>]...[/img] &nbsp; Afbeelding met uitlijning: left/right/middle...<br />
	[url]...[/url] &nbsp; Link naar ...<br />
	[mail]...[/mail] &nbsp; E-Mail naar ...<br />
</div>
</div>

<div class=help_entry>
<div class=keyword>Code en quotaties</div>
<div class=content>
	[code]...[/code] &nbsp; Broncode<br />
	[code=php]...[/code] &nbsp; Broncode met PHP syntaxis<br />
	[quote]...[/quote] &nbsp; Quotatie<br />
	[quote=<i>xxx</i>]...[/quote] &nbsp; Quotatie door <i>xxx</i><br />
	[indent]...[/indent] &nbsp; Ingesprongen tekstblok<br />
	[indent=<i>n</i>]...[/indent] &nbsp; Ingesprongen textblog met <i>n</i> pixels<br /><br />

	Eenvoudige quotatie: &nbsp; |" ... "|<br />
	&nbsp; &nbsp; <i>(zie bovenstaande nota over de Basisopmaak)</i><br /><br />

	Je kan syntaxiskleuring inschakelen met de [code] tags door de naam van de taal als parameter te gevenr. Momenteel zijn de volgende talen ondersteund:<br />
	PHP (PHP eigen functie), C (niet foutloos)
</div>
</div>

<div class=help_entry>
<div class=keyword>Diversen</div>
<div class=content>
	[line] &nbsp; Horizontale lijn, of: &nbsp; ---- (ten minste 4 koppeltekens)<br />
	[line=<i>color</i>] &nbsp; Lijn met kleur <i>color</i><br />
	[line=<i>color</i>:<i>size</i>] &nbsp; Lijn met kleur <i>color</i> en breedte <i>size</i><br />
</div>
</div>

<p>
Alles tussen [#] and [/#] zal niet gecontroleerd of veranderd worden. Enkele tags kunnen gemaskeerd worden door \[ te schrijven voor een [. [rem]...[/rem] zijn commentaren die niet getoond zullen worden.
</p>

<p>
Harde enters rond tags vormen een paragraaf op zich (bv. [code], [quote], [align], [line]) en zullen verwijderd worden. Ook waar de [code] tag in een eigen lijn staat, zullen geen nieuwe lijnen weergegeven worden.
</p>

<p>
Deze tabel toont de omzetting van lettergroottes van pt (punten) naar px (pixels):<br />
&nbsp; 7pt -- 9px<br />
&nbsp; 8pt -- 11px<br />
&nbsp; 10pt -- 13px<br />
&nbsp; 12pt -- 16px<br />
&nbsp; 14pt -- 19px<br />
</p>

<p>
<i>Om deze conventies gewoon te worden, kan je de <b>Voorvertoning</b> eerst gebruiken om je bericht na te kijken.</i>
</p>

<p>
ESC (Escape) sluit dit venster.
</p>

<p>
<small>Je vindt meer informatie over de ABBC parser en zijn taal op de <a href="<?= $MODULE['derefer'] . PD ?>url=http://software.unclassified.de/abbc" target=_blank>ABBC website</a>.</small>
</p>
