<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// main.inc.php
// Forums and Threads list page

require_once($libpath . 'common_post.lib.php');
#if ($LoginUserID == 58) echo '<b>main begin ------ ' . perform_msec() . 'ms</b><br />';


// TODO: integrate this somehow...
$T['unread_accesskey'] = 'u';


// Import request variables
$toplevel = intval($_GET['id']);
if ($toplevel < -1) $toplevel = 0;

$where = $_GET['where'];

$addparent = intval($_GET['addparent']);
if ($addparent < 0 || !isset($_GET['addparent'])) $addparent = -1;

$editforum = intval($_GET['editforum']);
if ($editforum <= 0) $editforum = -1;

$editthread = intval($_GET['editthread']);
if ($editthread <= 0) $editthread = -1;

$page = intval($_GET['page']);
if ($page < 1) $page = 1;

// Guests' language selection
//
if (isset($_GET['set_lang']))
{
	if ($_GET['set_lang'] != '')
	{
		setcookie('pref_language', $_GET['set_lang'], time() + 3600 * 24 * 365);
	}
	else
	{
		setcookie('pref_language');
		unset($pref_language);
	}
	$_SESSION['pref_language'] = $_GET['set_lang'];
	ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();
}

if (isset($_GET['collapse']))
{
	$forum = new IForum;
	$forum->SetCatState(0, $_GET['collapse']);
	addlog('collapse_forum ' . $_GET['collapse']);
	/*ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();*/
}
if (isset($_GET['expand']))
{
	$forum = new IForum;
	$forum->SetCatState(1, $_GET['expand']);
	addlog('expand_forum ' . $_GET['expand']);
	/*ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();*/
}

// Add watching method
//
if (isset($_GET['watch']) && $LoginUserID > 0)
{
	$forum = new IForum;
	if ($forum->Load($toplevel))
	{
		$mode = intval($forum->IsWatched());
		$mode |= intval($_GET['watch']);
		$forum->SetWatched($mode, 0, 0);   // not recursive
	}
	addlog('watch_forum ' . $toplevel . ' mode ' . $_GET['watch']);
}

// Remove watching method
//
if (isset($_GET['unwatch']) && $LoginUserID > 0)
{
	$forum = new IForum;
	if ($forum->Load($toplevel))
	{
		$mode = intval($forum->IsWatched());
		$mode = $mode & ~intval($_GET['unwatch']);
		$forum->SetWatched($mode, 0, 0);   // not recursive
	}
	addlog('unwatch_forum ' . $toplevel . ' mode ' . $_GET['unwatch']);
	if (intval($_GET['b2p']) > 0)   // go Back2Profile...
	{
		ForwardHTML($MODULE['cp'] . PD . 'id=' . $_GET['b2p'] . '&amp;item=3' . sid());
		exit();
	}
}

// Mark a thread as unread from a specified post on
//
if ($_GET['threadunread'] > 0 && isset($_GET['threadunread_time']))
{
	#if (CheckRights('viewforum', /*forum*/ 0, /*thread*/ 0))
	{
		$thread = new IThread;
		$thread->SetLastRead($_GET['threadunread_time'], $_GET['threadunread'], /*force*/ true);

		addlog('set_last_read ' . $_GET['threadunread']);
		#ForwardHTML($ME . PD . 'id=' . $toplevel . sid());
		#exit();
	}
}


$error = false;
$info = false;

// Add a Forum
//
if ($_POST['action'] == 'addforum' && CheckRights('addforum', $_POST['Parent']))
{
	$sort = trim($_POST['Sort']);
	$name = trim($_POST['Name']);
	$desc = trim($_POST['Description']);
	$link = trim($_POST['Link']);

	$forum = new IForum;
	if ($sort == '' || !is_numeric($sort))
	{
		$sort = $db->FastQuery1st('Forums', 'MAX(`Sort`)', 'Parent=' . $_POST['Parent']) + 1;
	}

	// check data
	if ($name == '')
	{
		$error .= $T['err_no_name_given'] . '<br />';
	}

	if (!$error)
	{
		$flags = 0;
		if ($_POST['IsCategory']) $flags += 1;
		if (!$_POST['IsCategory'] && $_POST['IsLink']) $flags += 2;

		if (!$forum->Add($sort, $_POST['Parent'], $name, $flags, $desc, $link))
		{
			addlog('add_forum error');
			$error .= $T['err_forum_not_created'] . ' (' . t2h($forum->db->LastError()) . ')<br />';
		}
		else
		{
			addlog('add_forum ' . $forum->GetID() . ' ok');
			ForwardHTML($CFG['mod_rewrite'] ?
				'f.' . $toplevel . sid(3) :
				$ME . PD . 'id=' . $toplevel . sid());   // $toplevel was: $_POST['Parent']
			exit();
		}
	}
	unset($forum);
}

// Edit a Forum
//
if ($_POST['action'] == 'editforum' && CheckRights('editforum', $_POST['ID']))
{
	$forum = new IForum;
	$forum->Load($_POST['ID']);

	if ($_POST['Remove'] == 1)
	{
		// recursively delete the forum with any related contents
		// (threads, posts, polls, category states, votes, notifications)
		if (!$forum->Remove($_POST['ID']))
		{
			addlog('remove_forum ' . $_POST['ID'] . ' error');
			$error .= $T['err_forum_not_deleted'] . ' (' . t2h($forum->db->LastError()) . ')<br />';
		}
		else
		{
			addlog('remove_forum ' . $_POST['ID'] . ' ok');
			ForwardHTML($CFG['mod_rewrite'] ?
				'f.' . $toplevel . sid(3) :
				$ME . PD . 'id=' . $toplevel . sid());
			exit();
		}
	}
	else
	{
		$name = trim($_POST['Name']);
		$desc = trim($_POST['Description']);
		$link = trim($_POST['Link']);

		// check data
		if ($name == '')
		{
			$error .= $T['err_no_name_given'] . '<br />';
		}

		if (!$error)
		{
			$flags = 0;
			if ($_POST['IsCategory']) $flags += 1;
			if (!$_POST['IsCategory'] && $_POST['IsLink']) $flags += 2;

			if (!$forum->Change($_POST['ID'], $_POST['Sort'], $_POST['Parent'], $name, $flags, $desc, $link))
			{
				addlog('edit_forum ' . $_POST['ID'] . ' error');
				$error .= $T['err_forum_not_changed'] . ' (' . t2h($forum->db->LastError()) . ')<br />';
			}
			else
			{
				addlog('edit_forum ' . $_POST['ID'] . ' ok');
				ForwardHTML($CFG['mod_rewrite'] ?
					'f.' . $toplevel . sid(3) :
					$ME . PD . 'id=' . $toplevel . sid());
				exit();
			}
		}
	}

	unset($forum);
}

// Edit a Thread
//
if ($_POST['action'] == 'editthread')
{
	$thread = new IThread;
	$thread->Load($_POST['ID']);
	if (isset($_POST['Forum']))
		$forumid = trim($_POST['Forum']);
	else
		$forumid = $thread->GetForum();

	if (CheckRights('editpost', $forumid, $thread->GetID(), 0))
	{
		if ($_POST['Remove'] == 1)
		{
			if (!$thread->RemoveAllPosts($_POST['ID']))
			{
				addlog('remove_thread ' . $_POST['ID'] . ' error');
				$error .= $T['err_thread_not_deleted'] . ' (' . t2h($thread->db->LastError()) . ')<br />';
			}
			else
			{
				addlog('remove_thread ' . $_POST['ID'] . ' ok');
				ForwardHTML($CFG['mod_rewrite'] ?
					'f.' . $forumid . sid(3) :
					$ME . PD . 'id=' . $forumid . sid());
				exit();
			}
		}
		else
		{
			$subject = trim($_POST['Subject']);
			$desc = trim($_POST['Desc']);

			// check data
			if ($subject == '')
			{
				$error .= $T['err_no_topic_given'] . '<br />';
			}

			if ($forumid < 1)
			{
				$error .= $T['err_invalid_forum_id'] . '<br />';
			}

			if (!$error)
			{
				$opt = $thread->GetOptions();
				if (CheckRights('closethread', $thread->GetForum(), $thread->GetID())) $opt = ($opt & ~1) | ($_POST['CloseThread'] ? 1 : 0) * 1;
				if (CheckRights('importantthread', $thread->GetForum(), $thread->GetID())) $opt = ($opt & ~2) | ($_POST['ImportantThread'] ? 1 : 0) * 2;

				// see if we want to move the thread
				if ($thread->GetForum() != $forumid && $_POST['MovedLink'] == 1)
				{
					$thread2 = new IThread;
					$thread2->Add($thread->GetForum(), $thread->GetUserName(), $subject, $opt | 8, $thread->GetDate());
					$thread2->SetQuestion($_POST['ID'], time() + 14 * 24 * 3600);   // show "moved" link for 14 days
					$thread2->SetLastPostDate($thread->GetLastPostDate());
				}

				if (!$thread->Change(0, $forumid, -1, -1, $subject, $opt))
				{
					addlog('edit_thread ' . $thread->GetID() . ' error');
					$error .= $T['err_thread_not_changed'] . ' (' . t2h($thread->db->LastError()) . ')<br />';
				}
				else
				{
					$thread->SetDesc($desc);

					addlog('edit_thread ' . $thread->GetID() . ' ok');
					ForwardHTML($CFG['mod_rewrite'] ?
						'f.' . $forumid . sid(3) :
						$ME . PD . 'id=' . $forumid . sid());
					exit();
				}
			}
		}
	}

	unset($thread);
}

// Mark all Forums read
//
if ($_GET['allforumsread'] == 1 && $LoginUserID)
{
	$thread = new IThread;

	$t = time();
	$twa = $db->FastQuery1stArray('ThreadWatch', 'LastRead, Thread', 'User=' . $LoginUserID, '', '', '', 'Thread');
	$ta = $db->FastQueryArray('Threads', 'Forum, ID, LastPostDate', 'NOT (Options & 8)', '', '', '', 'ID');

	$updates = '';
	foreach ($ta as $id => $thread)
	{
		if ($thread['LastPostDate'] > $twa[$id] && CheckRights('viewforum', $thread['Forum']))
		{
			$updates .= ($updates !== '' ? ', ' : '') . "($id, $LoginUserID, $t)";
		}
	}

	if ($updates != '')
	{
		$pre = $db->tblprefix;
		$db->Exec("REPLACE INTO {$pre}ThreadWatch (Thread, User, LastRead) VALUES $updates");
	}

	addlog("all_forums_read");
	ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();
}

// Mark all Threads read
//
if ($_GET['allthreadsread'] == 1 && $LoginUserID && CheckRights('viewforum', $toplevel))
{
	$thread = new IThread;

	$t = time();
	$twa = $db->FastQuery1stArray('ThreadWatch', 'LastRead, Thread', 'User=' . $LoginUserID, '', '', '', 'Thread');
	$ta = $db->FastQueryArray('Threads', 'Forum, ID, LastPostDate', "Forum=$toplevel AND NOT (Options & 8)", '', '', '', 'ID');

	$updates = '';
	foreach ($ta as $id => $thread)
	{
		if ($thread['LastPostDate'] > $twa[$id])
		{
			$updates .= ($updates !== '' ? ', ' : '') . "($id, $LoginUserID, $t)";
		}
	}

	if ($updates != '')
	{
		$pre = $db->tblprefix;
		$db->Exec("REPLACE INTO {$pre}ThreadWatch (Thread, User, LastRead) VALUES $updates");
	}

	addlog('all_threads_read ' . $toplevel);
	ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();
}

// The following 3 functions are the same as in thread.inc.php!

// Mark a Message read
//
if ($_GET['messageread'] > 0 && $LoginUserID > 0)
{
	$message = new IMessage;
	if ($message->Load($_GET['messageread']))
	{
		$message->SetRead();
	}
	addlog('message_read ' . $_GET['messageread']);
	/*ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();*/
}

// Mark a Message unread
//
if ($_GET['messageunread'] > 0 && $LoginUserID > 0)
{
	$message = new IMessage;
	if ($message->Load($_GET['messageunread']))
	{
		$message->SetRead(false);
	}
	addlog('message_unread ' . $_GET['messageunread']);
	/*ForwardHTML($CFG['mod_rewrite'] ?
		'f.' . $toplevel . sid(3) :
		$ME . PD . 'id=' . $toplevel . sid());
	exit();*/
}

// Mark a Message unread for all users
//
if ($_GET['messageallunread'] > 0)
{
	$message = new IMessage;
	$message->Load($_GET['messageallunread']);

	if (CheckRights('editmessage', $message->GetForum()))
	{
		$message->RemoveAllReads($_GET['messageallunread']);

		addlog('message_all_unread ' . $_GET['messageallunread']);
		/*ForwardHTML($CFG['mod_rewrite'] ?
			'f.' . $toplevel . sid(3) :
			$ME . PD . 'id=' . $toplevel . sid());
		exit();*/
	}
}

// Send a new password request link to a User
//
if (intval($_GET['mkpass']) > 0)
{
	$userid = intval($_GET['mkpass']);
	$user = new IUser;
	if (!$user->Load($userid)) die($T['err_invalid_user']);

	// Generate key, see register.php
	mt_srand((double) microtime() * 1000000);
	$key = md5($userid . mt_rand(100000, 99999999) . time());
	$user->SetActivateKey($key);

	if (NotifyUser($userid, 1, 'mkpass_1_subject', array(), 'mkpass_1',
		array(
			'%u' => rc('home_url') . '/' . $MODULE['main'] . PD . 'mkpass2=' . $userid . '&amp;key=' . $key
		)))
	{
		addlog('request_new_password for ' . $userid . ' ok');
		ForwardHTML($ME . PD . 'id=' . $toplevel . '&amp;info=1' . sid());
		exit();
	}
	else
	{
		addlog('request_new_password for ' . $userid . ' error');
		ForwardHTML($ME . PD . 'id=' . $toplevel . '&amp;err=5' . sid());
		exit();
	}
}

// Generate a new password for a user
//
if (intval($_GET['mkpass2']) > 0)
{
	$userid = intval($_GET['mkpass2']);
	$key = $_GET['key'];
	$user = new IUser;
	if (!$user->Load($userid)) die($T['err_invalid_user']);

	if ($key == $user->GetActivateKey())
	{
		// Generate new password
		mt_srand((double) microtime() * 1000000);
		$newpass = '';
		for ($n = 0; $n < 10; $n++)
		{
			$s = mt_rand(0, 61);
			if ($s <= 9) $s += 0x30;
			elseif ($s <= 35) $s += 0x41 - 10;
			elseif ($s <= 61) $s += 0x61 - 36;

			$newpass .= chr($s);
		}

		$user->SetPassword(md5($newpass));
		$user->SetActivateKey("");

		addlog('make_new_password for ' . $userid . ' ok');

		if (NotifyUser($userid, 1, 'mkpass_2_subject', array(), 'mkpass_2', array('%pass%' => $newpass)))
		{
			ForwardHTML($ME . PD . 'id=' . $toplevel . '&amp;info=2' . sid());
			exit();
		}
		else
		{
			ForwardHTML($ME . PD . 'id=' . $toplevel . '&amp;err=5' . sid());
			exit();
		}
	}
	else
	{
		addlog('make_new_password for ' . $userid . ' error');
		ForwardHTML($ME . PD . 'id=' . $toplevel . '&amp;err=6' . sid());
		exit();
	}
}


// Login error messages
if ($_GET['err'] == 1) $error .= $T['err_login_failed'] . ': ' . $T['err_no_username_given'] . '<br />';
if ($_GET['err'] == 2) $error .= $T['err_login_failed'] . ': ' . $T['err_unknown_username'] . '<br />';
if ($_GET['err'] == 3) $error .= $T['err_login_failed'] . ': ' . $T['err_wrong_password'] . ' <a href="' . $ME . PD . 'mkpass=' . $_GET['userid'] . sid() . '">' . $T['get_new_password'] . '</a><br />';
if ($_GET['err'] == 5) $error .= $T['err_email_not_sent'] . '<br />';
if ($_GET['err'] == 6) $error .= $T['err_invalid_key'] . '<br />';

if ($_GET['info'] == 1) $info .= $T['mkpass_key_sent'] . '<br />';
if ($_GET['info'] == 2) $info .= $T['mkpass_password_sent'] . '<br />';


// Add a Forum <form>
// Needs <table> to be open
//
// parent = Forum to create the new Forum in
// level = 0,1: Table level, for indenting
//
function AddForum($parent, $level)
{
	global $ME, $IMG, $toplevel, $TABLE, $output, $T;

	$show_threads_posts = rc('count_forum_threads_posts');
	$show_lastpost = rc('display_forum_lastpost');

	$output .= '<form action="' . $ME . PD . 'id=' . $toplevel . '&amp;i=1' . sid() . '" method="post"><tr valign="top">';

	if ($level > 0)
	{
		$output .= '<td class="list_forum">&nbsp;</td>';
	}
	$output .= '<td class="list_editforum" valign="middle">';
	$output .= '<img ' . $IMG['forum_edit'] . ' title="' . $T['img_new_forum'] . '" />';
	$output .= '</td>';

	$output .= '<td class="list_editforum" colspan="' . (2 - $level) . '">';
	$output .= '<a name="here"></a>';
	$output .= '<input type="hidden" name="action" value="addforum" />';
	$output .= '<input type="hidden" name="Parent" value="' . $parent . '" />';

	$output .= '<table cellspacing="' . $TABLE['forum']['space'] . '" cellpadding="' . $TABLE['forum']['pad'] . '" border="' . $TABLE['forum']['border'] . '">';
	$output .= '<tr><td>' . $T['new_forum'] . ':</td><td><input type="text" class="text" name="Name" size="35" maxlength="100" /> <nobr><input type="checkbox" class="radio" name="IsCategory" id="IsCategory" value="1" /><label for="IsCategory">' . $T['category'] . '?</label> <input type="checkbox" class="radio" name="IsLink" id="IsLink" value="1" /><label for="IsLink">' . $T['weblink'] . '?</label></nobr></td></tr>';
	$output .= '<tr><td>' . $T['description'] . ':&nbsp;</td><td><input type="text" class="text" name="Description" size="45" /></td></tr>';
	$output .= '<tr><td>' . $T['link_url'] . ':&nbsp;</td><td><input type="text" class="text" name="Link" size="45" maxlength="255" /></td></tr>';
	$output .= '<tr><td>' . $T['order'] . ':</td><td><input type="text" class="text" name="Sort" size="3" maxlength="3" /></td></tr>';
	$output .= '</table>';

	$cols = 0;
	if ($show_threads_posts) $cols += 2;
	if ($show_lastpost) $cols += 2;
	if ($cols > 0) $output .= '</td><td class="list_editforum" colspan="' . $cols . '" align="right" valign="middle">';

	$output .= '<input type="submit" class="button" value="' . $T['save'] . '" /><br />';
	$output .= '<img ' . $IMG['empty'] . ' width="1" height="18" /><a href="' . $ME . PD . 'id=' . $toplevel . sid() . '">' . $T['cancel'] . '</a>';
	$output .= '</td>';
	$output .= '</tr></form>';
}

// Edit a Forum <form>
// Needs <table> to be open
//
// ID = Forum to change
// level = 0,1: Table level, for indenting
// threads = how many threads are in this forum?
//
function EditForum($ID, $level, $threads = 0)
{
	global $ME, $IMG, $toplevel, $TABLE, $output, $T;

	$show_threads_posts = rc('count_forum_threads_posts');
	$show_lastpost = rc('display_forum_lastpost');

	$forum = new IForum;

	$forum->Load($ID);

	$output .= '<form action="' . $ME . PD . 'id=' . $toplevel . sid() . '" method="post"><tr valign="top">';

	if ($level > 0)
	{
		$output .= '<td class="list_forum">&nbsp;</td>';
	}
	$output .= '<td class="list_editforum" valign="middle">';
	$output .= '<img ' . $IMG['forum_edit'] . ' vspace="1" hspace="1" title="' . $T['img_change_forum'] . '" />';
	$output .= '</td>';

	$output .= '<td class="list_editforum" colspan="' . (2 - $level) . '">';
	$output .= '<input type="hidden" name="action" value="editforum" />';
	$output .= '<input type="hidden" name="ID" value="' . $ID . '" />';
	$output .= '<input type="hidden" name="Parent" value="' . $forum->GetParent() . '" />';

	$output .= '<table cellspacing="' . $TABLE['forum']['space'] . '" cellpadding="' . $TABLE['forum']['pad'] . '" border="' . $TABLE['forum']['border'] . '">';
	$output .= '<tr><td>' . $T['name'] . ':</td><td><input type="text" class="text" name="Name" size="35" maxlength="100" value="' . t2h($forum->GetName()) . '" /> <nobr>';
	if (!$threads) $output .= '<input type="checkbox" class="radio" name="IsCategory" id="IsCategory" value="1"' . ($forum->IsCategory() ? ' checked="checked"' : '') . ' /><label for="IsCategory">' . $T['category'] . '?</label> ';
	$output .= '<input type="checkbox" class="radio" name="IsLink" id="IsLink" value="1"' . ($forum->IsLink() ? ' checked="checked"' : '') . ' /><label for="IsLink">' . $T['weblink'] . '?</label></nobr></td></tr>';
	$output .= '<tr><td>' . $T['description'] . ':&nbsp;</td><td><input type="text" class="text" name="Description" size="45" value="' . t2h($forum->GetDescription()) . '" /></td></tr>';
	$output .= '<tr><td>' . $T['link_url'] . ':&nbsp;</td><td><input type="text" class="text" name="Link" size="45" maxlength="255" value="' . t2h($forum->GetLink()) . '" /></td></tr>';
	$output .= '<tr><td>' . $T['order'] . ':</td><td><input type="text" class="text" name="Sort" size="3" maxlength="3" value="' . $forum->GetSort() . '" />';
	$output .= '</td></tr></table>';

	$cols = 0;
	if ($show_threads_posts) $cols += 2;
	if ($show_lastpost) $cols += 2;
	if ($cols > 0) $output .= '</td><td class="list_editforum" colspan="' . $cols . '" align="right" valign="middle">';

	$output .= '<input type="submit" class="button" value="' . $T['save'] . '" /><br />';
	$output .= '<img ' . $IMG['empty'] . ' width="1" height="18" /><a href="' . $ME . PD . 'id=' . $toplevel . sid() . '">' . $T['cancel'] . '</a><br />';
	$output .= '<input type="checkbox" class="radio" name="Remove" id="Remove" value="1" ' . suredelete() . ' /><label for="Remove">' . $T['delete'] . '?</label>';
	$output .= '</td>';

	$output .= '</tr></form>';
}

// Count Posts per Forum, Threads per Forum, is Forum new? for ALL Forums
//
function CountForums()
{
	global $PostsPerForum, $ThreadsPerForum, $NewForums, $db, $LoginUserID;

	$pre = $db->tblprefix;
	$sql = "SELECT {$pre}Threads.Forum, COUNT(*) " .
		"FROM {$pre}Threads, {$pre}Posts " .
		"WHERE {$pre}Threads.ID = {$pre}Posts.Thread " .
		"GROUP BY {$pre}Threads.Forum";
	$db->Exec($sql);

	$PostsPerForum = array();
	while ($record = $db->GetRecord())
	{
		$PostsPerForum[$record[0]] = $record[1];
	}

	$sql = "SELECT Forum, COUNT(*) " .
		"FROM {$pre}Threads " .
		"WHERE NOT (Options & 8) " .
		"GROUP BY Forum";
	$db->Exec($sql);

	$ThreadsPerForum = array();
	while ($record = $db->GetRecord())
	{
		$ThreadsPerForum[$record[0]] = $record[1];
	}

	// the $NewForums array is used by IForum::IsNew()

	$NewForums = array();
	if ($LoginUserID)
	{
		$db->Exec("SELECT {$pre}Threads.Forum, COUNT(*) " .
			"FROM {$pre}Threads LEFT JOIN {$pre}ThreadWatch ON " .
				"({$pre}Threads.ID = {$pre}ThreadWatch.Thread AND {$pre}ThreadWatch.User = $LoginUserID) " .
			"WHERE ({$pre}ThreadWatch.LastRead<{$pre}Threads.LastPostDate OR {$pre}ThreadWatch.LastRead IS NULL) AND " .
				"({$pre}Threads.Options & 8 = 0) " .
			"GROUP BY {$pre}Threads.Forum");

		while ($record = $db->GetRecord())
		{
			$NewForums[$record[0]] = $record[1];
		}
	}
}

// Return number of Posts/Threads in a Forum
// Reads value from global array, so expects CountForums() to be called before
//
function GetPostsInForum($forumid)
{
	global $PostsPerForum;
	if (isset($PostsPerForum[$forumid]))
		return $PostsPerForum[$forumid];
	else
		return 0;
}

function GetThreadsInForum($forumid)
{
	global $ThreadsPerForum;
	if (isset($ThreadsPerForum[$forumid]))
		return $ThreadsPerForum[$forumid];
	else
		return 0;
}

// Return an array(ID => array(ID, Date, User, UserName, Thread, Subject)) of the Last Posts in some Forums
// Multi-Forum version! Input is an array(ID) of Forum IDs
// If no parameter is passed, return value contains ALL Forums (may be more efficient)
//
function GetLastPostInForumA($forumids_array = 0)
{
	global $db;

	if (is_array($forumids_array))
	{
		$forumids = join(',', $forumids_array);
	}
	else
	{
		$forumids = false;
	}

	$dates = $db->FastQuery1stArray('Threads', 'MAX(LastPostDate)',
		'NOT (Options & 8)' . ($forumids ? " AND Forum IN ($forumids)" : ''),
		'', '', 'Forum');
	if (!$dates) return array();   // no threads found in this timespan

	$pre = $db->tblprefix;
	$sql = "SELECT {$pre}Posts.ID AS PostID, {$pre}Posts.Date, {$pre}Posts.Thread, {$pre}Posts.User, {$pre}Posts.UserName, " .
			"{$pre}Threads.Forum, {$pre}Threads.Subject " .
		"FROM {$pre}Threads LEFT JOIN {$pre}Posts " .
			"ON {$pre}Threads.ID = {$pre}Posts.Thread " .
			"AND {$pre}Posts.Date = {$pre}Threads.LastPostDate " .
		"WHERE {$pre}Threads.LastPostDate IN (" . join(',', $dates) . ") " .
		"ORDER BY {$pre}Posts.Date DESC";
	$db->Exec($sql);

	$arr = array();
	$user = new IUser;

	#while ($record = $db->GetRecord())
	while ($record = @mysql_fetch_array($db->result))
	{
		if (!array_key_exists($record['Forum'], $arr))
		{
			$arr[$record['Forum']] = array('ID' => $record['PostID'],
										   'Date' => $record['Date'],
										   'User' => $record['User'],
										   'UserName' => $record['UserName'],
										   'Thread' => $record['Thread'],
										   'Subject' => $record['Subject']
										   );
		}
	}

	$users = array();
	foreach ($arr as $entry) array_push($users, $entry['User']);

	if (sizeof($users))
	{
		build_entire_user_cache($users);

		foreach ($arr as $key => $entry)
		{
			if ($user->Load($entry['User'])) $arr[$key]['UserName'] = $user->GetName();
		}
	}

	return $arr;
}

// List forums (recursive)
//
// parent = Toplevel Forum for this call
// level = 0,1,2: Table/Recursion level, for indenting
// addparent = Forum to show Add <form> in
// editforum = Forum to show Edit <form> for
//
function ListForums($parent = 0, $level = 0, $addparent = 0, $editforum = 0)
{
	global $MODULE, $ME, $IMG, $TABLE, $db, $toplevel, $LoginUser, $LoginUserID, $forums_count, $output, $lastposts, $T, $CFG;

	if ($parent > 0 && !CheckRights('viewforum', $parent)) return false;

	$forum = new IForum;
	$childs = $forum->GetChildA($parent);
	if (!$childs && $addparent == -1 && (!CheckRights('addforum', $parent) || $parent > 0))
	{
		// display a warning message on the overview page, if no forums can be displayed
		if (!$level && !$parent)
		{
			echo '<p class="error">' . $T['err_no_forums'] . '</p>';
		}
		return false;
	}

	$show_threads_posts = rc('count_forum_threads_posts');
	$show_lastpost = rc('display_forum_lastpost');

	$table_head  = '<table cellspacing="' . $TABLE['forum']['space'] . '" cellpadding="' . $TABLE['forum']['pad'] . '" border="' . $TABLE['forum']['border'] . '" width="100%"' . $TABLE['forum']['fixed'] . '>';
	$table_head .= '<colgroup>';
	$table_head .= '<col width="' . $TABLE['forum']['col_icon'] . '" />';
	$table_head .= '<col width="' . $TABLE['forum']['col_icon'] . '" />';
	$table_head .= '<col />';
	if ($show_threads_posts)
	{
		$table_head .= '<col width="65" align="center" />';
		$table_head .= '<col width="65" align="center" />';
	}
	if ($show_lastpost)
	{
		$table_head .= '<col width="210" align="right" />';
		$table_head .= '<col width="24" align="right" />';
	}
	$table_head .= '</colgroup>';

	// determine the right-most column
	$class_forum = '0';
	$class_posts = '0';
	if (!$show_lastpost)
	{
		$class_posts = 'right';
		if (!$show_threads_posts)
		{
			$class_forum = 'right';
		}
	}

	$table_head .= '<tr valign="top">';
	$table_head .= '<td class="list_forum_head_left" width="14">&nbsp;</td>';
	$table_head .= '<td class="list_forum_head_' . $class_forum . '" colspan="2">' . $T['forum'] . '</td>';
	if ($show_threads_posts)
	{
		$table_head .= '<td class="list_forum_head_0" width="65" align="center">' . $T['threads'] . '</td>';
		$table_head .= '<td class="list_forum_head_' . $class_posts . '" width="65" align="center">' . $T['posts'] . '</td>';
	}
	if ($show_lastpost)
		$table_head .= '<td class="list_forum_head_right" colspan="2" width="224" align="right">' . $T['last_post'] . '</td>';
	$table_head .= '</tr>';

	$thread = new IThread;
	$post = new IPost;
	$user = new IUser;

	if (!$level)
	{
		$output = '';
		$forums_count = 0;

		build_entire_forum_cache();
		CountForums();
		if ($show_lastpost) $lastposts = GetLastPostInForumA();   // get ALL LastPosts at once, saves much time on database
	}

	if ($childs)
	{
		if ($level >= 2)
		{
			$visible = false;

			foreach ($childs as $child)
			{
				$forum->LoadFromRecord($childs[0]);
				if (CheckRights('viewforum', $forum->GetID())) $visible = true;
			}

			if ($visible)
			{
				$output .= '<tr>';
				$output .= '<td class="list_forum" colspan="2"><small>&nbsp;</small></td>';
				$cols = 1;
				if ($show_threads_posts) $cols += 2;
				if ($show_lastpost) $cols += 2;
				$output .= '<td class="list_forum_more" colspan="' . $cols . '"><small>' . $T['more_forums'] . ': ';
				$n = 0;
				foreach ($childs as $child)
				{
					$forum->LoadFromRecord($child);
					if (CheckRights('viewforum', $forum->GetID()) && !$forum->IsLink())
					{
						if ($n) $output .= ', ';
						$output .= '<a href="' .
							($CFG['mod_rewrite'] ?
								'f.' . $forum->GetID() . sid(3) :
								$ME . PD . 'id=' . $forum->GetID() . sid()) .
							'">' . t2h($forum->GetName()) . '</a>';

						$n++;
					}
				}
				$output .= '</small></td>';

				$output .= '</tr>';
			}
		}
		else
		{
			// this is done once at level 0
			#$forumids = array();
			#foreach ($childs as $child) array_push($forumids, $child['ID']);
			#$lastposts = GetLastPostInForumA($forumids);

			$lastType = '';
			foreach ($childs as $child)
			{
				$forum->LoadFromRecord($child);

				if (CheckRights('viewforum', $forum->GetID()))
				{
					if (!$forums_count) $output .= $table_head;
					$forums_count++;

					if ($forum->IsLink())
					{
						$target = !$LoginUserID || $LoginUser->GetFlags() & 128 ? ' target="_blank"' : '';

						$output .= '<tr>';
						if ($level > 0) $output .= '<td class="list_forum">&nbsp;</td>';

						$output .= '<td class="list_weblink" align="center">';
						if ($forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
							$output .= '<a name="here"></a>';
						$output .= '<a href="' . $MODULE['derefer'] . PD . 'url=' . urlencode($forum->GetLink()) . sid() . '"' . $target . '><img ' . $IMG['weblink'] . ' title="' . $T['weblink'] . '" /></a>';
						$output .= '</td>';

						$cols = 2;
						if ($show_threads_posts) $cols += 2;
						if ($show_lastpost) $cols += 2;
						$output .= '<td class="list_weblink" colspan="' . ($cols - $level) . '">';
						$output .= '<span class="name"><a href="' . $MODULE['derefer'] . PD . 'url=' . urlencode($forum->GetLink()) . sid() . '"' . $target . '>' . t2h($forum->GetName()) . '</a></span> &nbsp; ';
						if (CheckRights('editforum', $forum->GetID())) $output .= ' <a href="' . $ME . PD . 'id=' . $toplevel . '&amp;editforum=' . $forum->GetID() . sid() . '#here"><img ' . $IMG['edit'] . ' title="' . $T['img_change_forum'] . '" /></a>';
						if ($forum->GetDescription() != '')
							$output .= '<div class="desc">' . abbc_proc($forum->GetDescription()). '</div>';
						$output .= '</td>';
						$output .= '</tr>';

						if ($forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
							EditForum($forum->GetID(), $level, 0);

						$lastType = 'link';
					}
					elseif ($forum->IsCategory())
					{
						$cols = 2;
						if ($show_threads_posts) $cols += 2;
						if ($show_lastpost) $cols += 2;

						// category spearator line
						if ($forums_count > 1 && !$level)
							$output .= '<tr><td colspan="' . ($cols + 1) . '">&nbsp;</td></tr>';

						$state = $forum->GetCatState();
						$img = ($state ? 'minus' : 'plus');
						$action = ($state ? 'collapse' : 'expand');
						$title = ($state ? $T['hide_contents'] : $T['show_contents']);

						$output .= '<tr>';
						if ($level > 0) $output .= '<td class="list_forum">&nbsp;</td>';

						$output .= '<td class="list_category" align="center">';
						if ($forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
							$output .= '<a name="here"></a>';
						if ($LoginUserID) $output .= '<a href="' . $ME . PD . 'id=' . $toplevel . '&amp;' . $action . '=' . $forum->GetID() . sid() . '">';
						$output .= '<img ' . $IMG[$img] . ' hspace="1" vspace="1" title="' . $title . '" />';
						if ($LoginUserID) $output .= '</a>';
						$output .= '</td>';

						$output .= '<td class="list_category" colspan="' . ($cols - $level) . '">';
						$output .= '<span class="name"><a href="' .
							($CFG['mod_rewrite'] ?
								'f.' . $forum->GetID() . sid(3) :
								$ME . PD . 'id=' . $forum->GetID() . sid()) .
							'">' . t2h($forum->GetName()) . '</a></span> &nbsp; ';
						if ($level == 0 && CheckRights('addforum', $forum->GetID()))
							$output .= ' <a href="' . $ME . PD . 'id=' . $toplevel . '&amp;addparent=' . $forum->GetID() . sid() . '#here"><img ' . $IMG['add'] . ' title="' . $T['img_new_forum'] . '" /></a>';
						if (CheckRights('editforum', $forum->GetID()))
							$output .= ' <a href="' . $ME . PD . 'id=' . $toplevel . '&amp;editforum=' . $forum->GetID() . sid() . '#here"><img ' . $IMG['edit'] . ' title="' . $T['img_change_forum'] . '" /></a>';
						if ($forum->GetDescription() != '')
							$output .= '<div class="desc">' . abbc_proc($forum->GetDescription()). '</div>';
						$output .= '</td>';
						$output .= '</tr>';

						if ($forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
							EditForum($forum->GetID(), $level, 0);

						if ($state && $level <= 3 && $child['ChildCount'] > 0 ||
						    $forum->GetID() == $addparent && CheckRights('addforum', $forum->GetID()))
							ListForums($forum->GetID(), $level + 1, $addparent, $editforum);

						$lastType = 'cat';
					}
					else
					{
						$img = 'forum';
						$title = $T['forum'];
						if ($forum->IsNew())
						{
							$img .= '_new';
							$title = $T['new_posts'];
						}

						// 'category' spearator line
						if ($forums_count > 1 && !$level && $lastType == 'cat')
							$output .= '<tr><td colspan="' . ($cols + 1) . '">&nbsp;</td></tr>';

						$output .= '<tr>';
						if ($level > 0) $output .= '<td class="list_forum">&nbsp;</td>';

						$output .= '<td class="list_forum" align="center">';
						if ($forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
							$output .= '<a name="here"></a>';
						$output .= '<a href="' .
							($CFG['mod_rewrite'] ?
								'f.' . $forum->GetID() . sid(3) :
								$ME . PD . 'id=' . $forum->GetID() . sid()) .
							'"><img ' . $IMG[$img] . ' title="' . $title . '" /></a>';
						$output .= '</td>';

						$output .= '<td class="list_forum" colspan="' . (2 - $level) . '">';
						$output .= '<span class="name"><a href="' .
							($CFG['mod_rewrite'] ?
								'f.' . $forum->GetID() . sid(3) :
								$ME . PD . 'id=' . $forum->GetID() . sid()) .
							'">' . t2h($forum->GetName()) . '</a></span><span class="desc"> &nbsp; ';
						if ($level == 0 && CheckRights('addforum', $forum->GetID()))
							$output .= ' <a href="' . $ME . PD . 'id=' . $toplevel . '&amp;addparent=' . $forum->GetID() . sid() . '#here"><img ' . $IMG['add'] . ' title="' . $T['img_new_forum'] . '" /></a>';
						if (CheckRights('editforum', $forum->GetID()))
							$output .= ' <a href="' . $ME . PD . 'id=' . $toplevel . '&amp;editforum=' . $forum->GetID() . sid() . '#here"><img ' . $IMG['edit'] . ' title="' . $T['img_change_forum'] . '" /></a>';
						if (!CheckRights('writeforum', $forum->GetID()))
							$output .= ' <img ' . $IMG['na'] . ' title="' . $T['you_must_not_post_here'] . '" />';
						$output .= '</span>';

						if ($forum->GetDescription() != '')
							$output .= '<div class="desc">' . abbc_proc($forum->GetDescription()). '</div>';
						$output .= '</td>';

						if ($show_threads_posts || $forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
						{
							$thread_count = GetThreadsInForum($forum->GetID());
						}
						if ($show_threads_posts)
						{
							$post_count = GetPostsInForum($forum->GetID());

							$output .= '<td class="list_forum" align="center">';
							$output .= ($thread_count ? $thread_count : '&nbsp;') . '</td>';

							$output .= '<td class="list_forum" align="center">';
							$output .= ($post_count ? $post_count : '&nbsp;') . '</td>';
						}

						if ($show_lastpost)
						{
							$output .= '<td class="list_forum" align="right">';
							$arr = $lastposts[$forum->GetID()];
							if ($arr)
							{
								$output .= '<small>';
								#$output .= MakePostLink($arr, 1, -1);
								$output .= FriendlyDate($arr['Date'], 1, 3);
								if (rc('display_thread_lastposter'))
								{
									$output .= ' ' . $T['by'] . ' ';
									if ($arr['User'] > 0)
										$output .= '<a href="' . $MODULE['cp'] . PD . 'id=' . $arr['User'] . sid() . '">' . t2h(str_limit($arr['UserName'], 30, true)) . '</a>';
									else
										$output .= t2h(str_limit($arr['UserName'], 30, true));
								}
								$output .= '<br />' . t2h(str_limit($arr['Subject'], 38, true));
								$output .= '</small>';
							}
							else
							{
								$output .= '&nbsp;';
							}
							$output .= '</td>';

							$output .= '<td class="list_forum" align="right">';
							if ($arr)
								$output .= MakePostLink($arr, 0, -1);
							else
								$output .= '&nbsp;';
							$output .= '</td>';
						}

						$output .= '</tr>';

						if ($forum->GetID() == $editforum && CheckRights('editforum', $forum->GetID()))
							EditForum($forum->GetID(), $level, $thread_count);

						if ($level <= 3 && $child['ChildCount'] > 0 ||
						    $forum->GetID() == $addparent && CheckRights('addforum', $forum->GetID()))
							ListForums($forum->GetID(), $level + 1, $addparent, $editforum);

						$lastType = 'forum';
					}
				}
			}  // foreach $childs
		}
	}

	if ($parent == $addparent && CheckRights('addforum', $parent))
	{
		if (!$forums_count) $output .= $table_head;
		$forums_count++;
		AddForum($parent, $level);
	}

	if (!$level)
	{
		if ($forums_count) $output .= '</table>';

		$x = '';
		$y = '';
		$new_forums = 0;

		if (!$parent && $forums_count)
		{
			if ($y != '') $y .= ' &nbsp; &nbsp; ';
			$y .= $T['current_topics_of_last_'];
			$y .= '<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;DateFrom=' . (time() - 1 * 24 * 3600) . '&amp;ResultView=1&amp;Sort=2&amp;title=1' . sid() . '">&nbsp;1&nbsp;</a>';
			$y .= '<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;DateFrom=' . (time() - 3 * 24 * 3600) . '&amp;ResultView=1&amp;Sort=2&amp;title=3' . sid() . '">&nbsp;3&nbsp;</a>';
			$y .= '<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;DateFrom=' . (time() - 7 * 24 * 3600) . '&amp;ResultView=1&amp;Sort=2&amp;title=7' . sid() . '">&nbsp;7&nbsp;</a>';
			$y .= $T['_days'];
			if ($LoginUserID)
			{
				$y .= ' ' . $T['or'] . ' ';
				$y .= ($CFG['mod_rewrite'] ?
						'<a href="new' . sid(3) . '">' :
						'<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;DateFrom=-3&amp;ResultView=1' . sid() . '">');
				$y .= $T['since_last_login'] . '</a>';
			}

			// Find unread threads
			if ($LoginUserID)
			{
				$pre = $db->tblprefix;
				$db->Exec("SELECT ID, Forum " .
					"FROM {$pre}Threads " .
						"LEFT JOIN {$pre}ThreadWatch ON {$pre}Threads.ID = {$pre}ThreadWatch.Thread AND {$pre}ThreadWatch.User = $LoginUserID " .
					"WHERE ({$pre}Threads.LastPostDate > {$pre}ThreadWatch.LastRead OR {$pre}ThreadWatch.LastRead IS NULL) AND NOT ({$pre}Threads.Options & 8)");
				$count = 0;
				while ($record = @mysql_fetch_array($db->result))
				{
					if (CheckRights('viewforum', $record['Forum'])) $count++;
				}
				if ($count)
				{
					if ($y != '') $y .= ' &nbsp; &nbsp; ';
					$y .= '<img ' . $IMG['unread'] . ' /> ';
					$y .= ($CFG['mod_rewrite'] ?
							'<a accesskey="' . $T['unread_accesskey'] . '" href="unread' . sid(3) . '">' :
							'<a accesskey="' . $T['unread_accesskey'] . '" href="' . $MODULE['search'] . PD . 'nodef=1&amp;DateFrom=-1&amp;ResultView=1' . sid() . '">') .
						($count == 1 ? $T['1_unread_topic'] : str_replace('%n', $count, $T['n_unread_topics'])) .
						'</a>';
					$new_forums = $count;
				}
			}

			// Find current polls
			$pre = $db->tblprefix;
			$threads = $db->FastQueryArray('Threads', 'ID, Forum',
				'(Options & 4) AND Question != "" AND NOT (Options & 8) AND Date >= ' . (time() - 3600 * 24 * rc('poll_current_days')) . " AND ({$pre}Threads.PollTimeout >= " . time() . " OR {$pre}Threads.PollTimeout = 0)");
			$count = 0;
			if (is_array($threads)) foreach ($threads as $record)
			{
				if (CheckRights('viewforum', $record['Forum'])) $count++;
			}
			if ($count)
			{
				if ($y != '') $y .= ' &nbsp; &nbsp; ';
				$y .= '<img ' . $IMG['votes'] . ' /> ';
				$y .= '<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;DateFrom=-2&amp;ResultView=1' . sid() . '">' .
					($count == 1 ? $T['1_current_poll'] : str_replace('%n', $count, $T['n_current_polls'])) .
					'</a>';
			}

			// Find bookmarks
			if ($LoginUserID)
			{
				//$count = sizeof($LoginUser->GetThreadWatchs(0, '&128'));
				$count = $db->FastQuery1st('ThreadWatch', 'COUNT(*)', "User=$LoginUserID AND Mode&128");
				if ($count)
				{
					if ($y != '') $y .= ' &nbsp; &nbsp; ';
					$y .= '<img ' . $IMG['bookmark'] . ' /> ';
					$y .= '<a href="' . $MODULE['cp'] . PD . 'item=4' . sid() . '">' .
						($count == 1 ? $T['1_bookmark'] : str_replace('%n', $count, $T['n_bookmarks'])) .
						'</a>';
				}
			}
		}

		if ($LoginUserID && $new_forums && $forums_count)
		{
			if ($x != '') $x .= ' &nbsp; &nbsp; ';
			$x .= '<a href="' . $ME . PD . 'id=' . $parent . '&amp;allforumsread=1' . sid() . '">' . $T['mark_all_forums_read'] . '</a>';
		}
		if (CheckRights('addforum', $toplevel))
		{
			if ($x != '') $x .= ' &nbsp; &nbsp; ';
			$x .= '<a href="' . $ME . PD . 'id=' . $toplevel . '&amp;addparent=' . $toplevel . sid() . '#here"><img ' . $IMG['add'] . ' /> ' . $T['create_new_forum'] . '</a>';
		}

		if ($y != '') echo '<div class="actionbar_r">' . $y . '</div>';
		echo $output;
		if ($x != '') echo '<div class="actionbar_r" style="text-align:right;">' . $x . '</div>';

		if (!$forums_count && !$toplevel)
		{
			echo '<p class="error">' . $T['err_no_forums'] . '</p>';
			return false;
		}
	}

	return true;
}

// List users that were online in the last 5 mins
//
// forumid may restrict the meaning of "being online" to a single forum
// -1: list users that were online this day only. no forum restriction here
//  0: any forum (useful for main page with overall statistics)
// >0: forum id
//
function ShowOnlineUsers($forumid)
{
	global $db, $MODULE, $T;
	if ($forumid < -1 || !CheckRights('showonlineusers')) return false;

	$output = '';

	if ($forumid == -1)
	{
		$last_0h = getdate(convert_timezone(time()));
		$last_0h = mktime(0, 0, 0, $last_0h['mon'], $last_0h['mday'], $last_0h['year']);

		#$a = localtime();
		#$last_0h = time() - (($a[2] * 60 + $a[1]) * 60 + $a[0]);

		// there can possibly be a second change between both above lines!
		// then $last_0h is ...1 what we have to correct now
		#$last_0h -= $last_0h % 5;

		$last_0h = convert_timezone($last_0h, true);
		$where = "LastActivity > " . $last_0h;
	}
	elseif ($forumid == 0)
		$where = 'LastActivity > ' . (time() - 5 * 60);
	else
		$where = 'LastActivity > ' . (time() - 5 * 60) . ' AND LastForum = ' . $forumid;

	$user = new IUser;

	$n = 0;
	if ($user->GetList($where, 'Name')) do
	{
		if ($n > 0) $output .= ', ';
		$output .= MakeUserLink($user->GetID(), $user->GetName());
		$n++;
	}
	while ($user->GetNext());

	if ($forumid == -1)
		if ($n == 0)
			$begin = '<div class="online_users">' . $T['today_no_user_was_online'] . ' ';
		elseif ($n == 1)
			$begin = '<div class="online_users">' . $T['today_one_user_was_online'] . ': ';
		else
			$begin = '<div class="online_users">' . str_replace('%s', $n, $T['today_n_users_were_online']) . ': ';
	elseif ($forumid == 0)
		if ($n == 0)
			$begin = '<div class="online_users">' . $T['currently_no_user_online'] . ' ';
		elseif ($n == 1)
			$begin = '<div class="online_users">' . $T['currently_one_user_online'] . ': ';
		else
			$begin = '<div class="online_users">' . str_replace('%s', $n, $T['currently_n_users_online']) . ': ';
	else
		if ($n == 0)
			$begin = '<div class="online_users">' . $T['no_user_in_forum'] . ' ';
		elseif ($n == 1)
			$begin = '<div class="online_users">' . $T['one_user_in_forum'] . ': ';
		else
			$begin = '<div class="online_users">' . str_replace('%s', $n, $T['n_users_in_forum']) . ': ';

	$guests = 0;
	if ($forumid == -1)
	{
		$guests = $db->FastQuery1st('Guests', 'COUNT(*)', 'LastActivity > ' . $last_0h);
	}
	elseif ($forumid == 0)
	{
		$guests = $db->FastQuery1st('Guests', 'COUNT(*)', 'LastActivity > ' . (time() - 5 * 60));
	}
	else
	{
		$guests = $db->FastQuery1st('Guests', 'COUNT(*)', 'LastActivity > ' . (time() - 5 * 60) . ' AND LastForum = ' . $forumid);
	}
	if ($guests) $output .= ' ' . $T['and'] . ' ';
	if ($guests == 1) $output .= $T['one_guest'];
	elseif ($guests > 1) $output .= str_replace('%s', $guests, $T['n_guests']);

	$output .= '</div>';

	echo $begin . $output;
	return true;
}

// List Users' birthdays
//
function ShowBirthdays()
{
	global $T, $IMG;

	$user = new IUser;

	$n = 0;
	if ($user->GetList('BirthDay=' . date('d') . ' AND BirthMonth=' . date('m'), 'Name')) do
	{
		if (!$n) echo '<div class="online_users"><img ' . $IMG['birthday'] . ' /> ' . $T['birthday_users'] . ': ';
		if ($n > 0) echo ', ';
		echo MakeUserLink($user->GetID(), $user->GetName());
		$x = intval(date('Y')) - $user->GetBirthYear();
		echo ' (' . $x . ')';
		$n++;
	}
	while ($user->GetNext());

	if ($n) echo '</div>';
	return true;
}

// if user doesn't have access to this forum (or it doesn't exist) STOP here
if ($toplevel > 0 && !CheckRights('viewforum', $toplevel))
{
	BeginHTML();
	echo '<p class="error">' . $T['err_invalid_forum'] . '</p>';
	EndHTML();
	#if ($CFG['code_before_exit']) eval($CFG['code_before_exit']);
	exit();
}


$forum = new IForum;
$forum->Load($toplevel);
addlog('view_forum ' . $toplevel . ' (' . $forum->GetName() . ')');
if ($LoginUserID) $LoginUser->SetLastActivity($toplevel);
else SetGuestLastForum($toplevel);

// Begin page
//
BeginHTML(t2h($forum->GetName()));

if ($error)
{
	echo '<p class="error">' . $error . '</p>';
	errorlog($error);
}

if ($info)
{
	echo '<p class="info">' . $info . '</p>';
}

ShowPath($toplevel);
if (!$toplevel && !$LoginUserID && sizeof($CFG['languages']) > 1)
{
	echo '<div class="path">' . $T['select_language'] . ': ';
	echo '<a href="' . $ME . PD . 'set_lang=">' . $T['default'] . '</a>';
	$img = '';
	foreach ($CFG['languages'] as $lang)
	{
		#$img = '<img src="' . $libpath . 'lang/' . $lang . '.gif" alt="" /> ';
		echo ' | ' . $img . '<a href="' . $ME . PD . 'set_lang=' . $lang . '">' . t2h($CFG['language_names'][$lang]) . ' (' . t2h($lang) . ')</a>';
	}
	echo '</div>';
}
if (!$toplevel && $LoginUserID && $LoginUser->GetActivateKey() != '' && !sizeof($LoginUserGroups))
{
	echo '<div class="path">';
	echo '<a href="' . $MODULE['register'] . PD . 'id=' . $LoginUserID . '&amp;resend=1">' . $T['resend_validation'] . '</a>';
	echo '</div>';
}
if ($toplevel > 0 && rc('show_online_users')) ShowOnlineUsers($toplevel);

if ($where == '')
{
	ListMessages($toplevel);
}

if ($where == '')
{
	$forums_found = ListForums($toplevel, 0, $addparent, $editforum);
}

if ($toplevel && $where == '')
{
	if (!$forum->IsCategory())
	{
		if ($forums_found) echo '<br />';
		ListThreads($toplevel, $page, $editthread);
	}
}
elseif ($where != '')
{
	if ($forums_found) echo '<br />';
	ListThreads($where, $page, $editthread);
}

if ((rc('show_goto_forum') || rc('show_search_forum')) && !(!$forums_found && !$toplevel))
{
	// TODO: <table/> must not be inside of <p/> (against XHTML 1.0 Transitional)
	//       but if I remove the <p/>, there's no more vertical margin...
	//       -> see Bug #147 ([Source code] XHTML compliance): Replace all <p/> with <div class="p"/>
	echo '<p><table cellspacing="0" cellpadding="0" width="100%"><tr><td>';
	if (rc('show_goto_forum')) JumpForumBox($toplevel);
	else echo '&nbsp;';
	echo '</td><td align="right">';
	if (rc('show_search_forum')) SearchTextbox($toplevel);
	else echo '&nbsp;';
	echo '</td></tr></table></p>';
}

if ($toplevel == 0 && $where == '')
{
	if (rc('show_online_users'))
	{
		#echo '<br />';
		ShowBirthdays();
		ShowOnlineUsers(0);
		ShowOnlineUsers(-1);
	}

	//if ($LoginUserID) echo '<div class="online_users">Letzter Besuch: ' . FormatTime($LoginUser->GetLastLogout(), 7) . '</div>';
}

UpdateStat("PageHits", 1);

EndHTML();
?>
