<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/license.txt for distribution/license details
//
// session.lib.php
// Session Library
// Widely taken from the Website Management System WMS, http://software.unclassified.de/wms

#
#  session.lib.php
#  
#  provides functions to start, terminate and check a user login session
#

$session_inactive = 30;   # kill session on ... minutes idle time (automatic re-login if cookie is present)

# disable trans-sid use
#
ini_set('session.use_trans_sid', '0');
#ini_set('session.use_cookies', '0');   # uncomment this to NEVER use cookies for session ID.
                                        # else they're only used when activated in the browser
                                        # (PHP will determine this automatically)

// create a session = login
//
// passwords must be passed md5-encrypted!
//
function create_session($UserID, $Password, $CorrectPassword, $AutoReLogin = true)
{
	global $prog_id;

	session_name('sid-' . $prog_id);
	session_start();

	if ($Password == '') return false;

	if ($_SESSION['invalids'] >= 5)
	{
		sleep(3);
		// silently fail login on more then 5 wrong passwords
		return false;
	}

	if ($Password != $CorrectPassword)
	{
		sleep(3);
		if (!isset($_SESSION['invalids']))
		{
			$_SESSION['invalids'] = 1;
		}
		else
		{
			$_SESSION['invalids']++;
		}

		if ($AutoReLogin)
		{
			setcookie('UserID', '', 1);
			setcookie('Password', '', 1);
		}
		return false;
	}

	$_SESSION['authd'] = true;
	$_SESSION['logintime'] = time();
	$_SESSION['accesstime'] = time();
	$_SESSION['invalids'] = 0;
	$_SESSION['prog_id'] = $prog_id;

	$_SESSION['UserID'] = intval($UserID);

	if ($AutoReLogin)
	{
		setcookie('UserID', $UserID, time() + 3600 * 24 * 365);
		setcookie('Password', $Password, time() + 3600 * 24 * 365);
	}
	return true;
}


function term_session()
{
	global $prog_id;

	session_name('sid-' . $prog_id);
	session_start();

	$_SESSION['authd'] = false;
	$_SESSION['UserID'] = 0;
	$_SESSION = array();
	session_destroy();

	setcookie('UserID', '', 1);
	setcookie('Password', '', 1);
}


function check_session()
{
	global $session_inactive;
	global $prog_id;

	session_name('sid-' . $prog_id);
	session_start();

	if ($_SESSION['prog_id'] != $prog_id)
	{
		return false;
	}
	if (!$_SESSION['authd'] || (time() - $_SESSION['accesstime'] > $session_inactive * 60))
	{
		return false;
	}

	$_SESSION['accesstime'] = time();
	return true;
}

?>