<?php
// BlackBoard RSS script
// Generate a newsfeed of threads

//---------- BEGIN CONFIGURATION

$forumid = $_REQUEST['forum'];   // Forum to read from. Cannot be 0
$limit = 20;                     // Limit number of news items (threads)
$type = 1;                       // Order by thread start date DESC
#$type = 2;                      // Order by last post date DESC -- not fully supported yet. See TODO

$format = 'RSS2.0';              // valid: RSS0.91, RSS1.0, RSS2.0, PIE0.1 (deprecated), OPML, ATOM, ATOM0.3
$filename = 'rss20.' . $forumid . '.xml';
$cache_time = 0;                 // don't use caching
#$cache_time = 3600;             // 1h

//---------- END CONFIGURATION

if (!$forumid) die('No forum ID specified.');

$abbc_cfg['derefer'] = '';
$abbc_cfg['target'] = '';

// Include BlackBoard's public library
// This must be the same path as in the forum.php file which should point to
// your board's installation library path.
$CONTTYPE = '';   // This custom Content-type header will be sent by public.lib, if not empty
require_once('bb_lib/public.lib.php');
require_once($libpath . 'common.lib.php');
#require_once($libpath . 'thread.lib.php');
#require_once($libpath . 'post.lib.php');
#require_once($libpath . 'user.lib.php');
require_once($libpath . 'feedcreator.lib.php');

ReadACL();

$abbc_cfg['subsets'] = ABBC_MINIMUM | ABBC_SIMPLE | ABBC_FONT | ABBC_URL | ABBC_IMG | ABBC_LIST | ABBC_SPECIAL | ABBC_DONTINT;
$abbc_cfg['output_div'] = false;

// FeedCreator: your local timezone, set to '' to disable or for GMT
// TODO: Copy from BlackBoard config. Is this necessary at all?
define('TIME_ZONE', '+01:00');

$filename = 'rss_cache/' . $filename;

$rss = new UniversalFeedCreator();
if ($cache_time) $rss->useCached($format, $filename, $cache_time);   // use cached version if age<1 hour
$rss->title = rc('forum_title') . ' News';
$rss->description = '';

//optional
$rss->descriptionTruncSize = 500;
$rss->descriptionHtmlSyndicated = true;

$rss->link = rc('home_url');

$thread = new IThread;
$post = new IPost;
$user = new IUser;

$order = '';
if ($type == 1) $order = 'Date DESC';
if ($type == 2) $order = 'LastPostDate DESC';
// TODO: What post(s) should be returned for type 2?

if ($thread->Find('Forum = ' . $forumid . ' AND NOT (Options & 8)', $order, $limit)) do
{
	if (!CheckRights('viewforum', $thread->GetForum(), $thread->GetID())) continue;

	$post->Find('Thread = ' . $thread->GetID(), 'Date', 1);
	$user->Load($post->GetUser());

	$url = rc('home_url') . '/' . $MODULE['thread'] . h2t(PD) . 'id=' . $thread->GetID();

	$item = new FeedItem();
	$item->title = $thread->GetSubject();
	if ($thread->GetDesc())
		$item->title .= ' (' . $thread->GetDesc() . ')';
	$item->link = $url;
	$item->description = abbc_proc($post->GetMsg());

	//optional
	$item->descriptionTruncSize = 500;
	$item->descriptionHtmlSyndicated = true;

	$item->date = $post->GetDate();

	$username = $user->GetName();
	if (!$username) $username = 'unknown';
	$item->author = $username;
	$item->guid = rc('home_url') . '/' . $thread->GetID();

	$rss->addItem($item);
}
while ($thread->FindNext());

$rss->saveFeed($format, $filename);

?>
